

import configuration.Config;
import configuration.Util;
import java.util.Collections;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import results.report;
import tools.Toolbox;
import tools.ToolboxMutableTreeNode;
import workflows.workflow_properties;
import workflows.workflow_properties_dictionnary;


/**
 * This will create the list of acknowledgment for the WelcomeMessage
 * @author Etienne Lord
 * @since September 2010
 */
public class Acknowledgment {

    Config config=new Config();
    workflow_properties_dictionnary dict=new workflow_properties_dictionnary();
    /**
     * Create the acknowledgment/getting started webpage in the  "Documents" directory
     * @return true if success
     */
   
    public Boolean createAcknowledgment() {
    //--Unsafe - call getAcknowledgment() - below
            try {
                Util u=new Util();
                u.open(config.get("getting_startedArmadillo"));
                u.println(this.getAcknowledgement());
                u.close();
            } catch(Exception e) {return false;}            
        return true;
    }
    
    /**
     * New function to create the opening screen
     * @return 
     */
    private String getAcknowledgement() {
        //--Variables
        StringBuilder st=new StringBuilder();
        
        //--The tools tree: easier because it's already shorted
            Toolbox toolbox=new Toolbox();
            JTree applications_tree=toolbox.getApplicationTree();
            DefaultTreeModel mode=(DefaultTreeModel) applications_tree.getModel();
            ToolboxMutableTreeNode treeroot=(ToolboxMutableTreeNode) mode.getRoot();   
            
        
        //--Headee + first table
        st.append("<!DOCTYPE html PUBLIC '-//W3C//DTD HTML 4.01//EN' 'http://www.w3.org/TR/html4/strict.dtd'><html><head> <meta http-equiv='content-type' content='text/html; charset=ISO-8859-1'> <link href='favicon.ico' rel='shortcut icon'><title>Getting Started</title></head> <body style='background-color: white; color: rgb(0, 0, 0);' alink='#000099' link='#000099' vlink='#990099'> <div id='logo'><div align='right'><div style='text-align: left;'><table style='text-align: left; width: 1073px; height: 805px;' border='0' cellpadding='0' cellspacing='0'> <tbody> <tr> <td style='width: 951px;'><div style='text-align: center;'><div style='text-align: left;'><big style='color: black;'><img style='width: 200px; height: 109px;' src='logo.png' alt=''><span style='font-weight: bold;'> </span></big><span style='font-weight: bold;'></span><br><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big style='color: black;'><big><big><span style='font-family: Courier New,Courier,monospace;'>http://bioinfo.uqam.ca/armadillo</span></big></big></big></small></span><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big style='color: black;'><big><big><span style='font-family: Courier New,Courier,monospace;'><br>armadillo.workflow@gmail.com</span></big></big></big></small></span><br></div><span style='font-weight: bold;'></span></div><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'><span style='font-weight: bold;'><br>Armadillo, a simple approach of automating comparative genomics tasks using workflows.</span><br>Etienne Lord, Mickael Leclercq, Alix Boc, Abdoulaye Baniré Diallo, Vladimir Makarenkov<br>Department of Computer Science, Universite du Quebec a Montreal, Montreal, PO Box 8888<br>Downtown Station, Montreal, QC, H3C 3P8</span></span><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big style='color: black;'><br><br></big></small></span><div style='text-align: justify;'><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><div style='margin: 0px;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'>The Armadillo workflow platform was first developed as an educational tool to help students understand the basic phylogenetic inference process using the PHYLIP package. However, it can now help life science researcher&#8217;s rapidly develop data-flux prototype and easily automate the analysis of multiple species phylogeny in an automated fashion, on a workstation. The current version (version 1.0) includes custom interface for software&#8217;s used in phylogenetic analysis such as search for orthologous genes, multiple sequence alignment (MSA), evolution model determination and inference of phylogeny using maximum likelihood or maximum parsimony. The workflows and their associated data are saved to a unique local database file, allowing the easy sharing of the developed workflow, annotation, analysis, and pipeline execution results to other re-searchers. Since the file is by itself a database, it can also be interrogated by using the database standard structured-query language (SQL). Additionally, this open-source software allows the scientific community to develop their own modules or to integrate other software&#8217;s into this application for their rapidstudy prototyping.</span></div></span></div><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big style='color: black;'><br></big></small></span><div style='text-align: center;'><div style='text-align: left;'><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big style='color: black;'><img style='width: 913px; height: 368px;' alt='' src='image.png'></big></small></span><br></div><div style='text-align: left;'><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'>Sample workflow created with the <span style='font-style: italic;'>Armadillo</span> workflow platform. Multiple protein sequences are first aligned with Muscle before a phylogenetic tree is inferred with PhyML or with ProtTest (PhyML) with different evolutionnary models. Finally, a tree distance is inferred with the Robinson and Fould methodology.</span></span><br><br><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'></span></span></div><hr style='width: 100%; height: 2px;'><div style='text-align: left;'><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'></span></span><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'><br><span style='font-weight: bold;'>Tutorials</span><br><br>Tutorials can be found on the website: <span style='font-weight: bold; font-family: Courier New,Courier,monospace;'>http://bioinfo.uqam.ca/armadillo</span><span style='font-family: Courier New,Courier,monospace;'></span><br></span></span><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'></span></span></div><span style='font-weight: bold;'></span></div><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big style='color: black;'><br></big></small></span><span style='font-weight: bold;'></span><hr style='width: 100%; height: 2px;'><span style='font-weight: bold;'></span></td></tr><tr><td style='vertical-align: top; width: 951px;'><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'>Armadillo make use of the following libraries (and their associated packages): </span></span><br style='font-family: Arial;'><br><table x:str='' style='border-collapse: collapse; width: 1046px; height: 124px;' border='1' cellpadding='0' cellspacing='0'><col style='width: 285pt;' width='380'> <tbody><tr><td style='text-align: center; font-style: italic; font-weight: bold; background-color: rgb(153, 153, 153);'>Libraries</td><td style='text-align: center; font-style: italic; font-weight: bold; background-color: rgb(153, 153, 153);'>Version</td><td style='text-align: center; font-style: italic; font-weight: bold; background-color: rgb(153, 153, 153);'>Links</td></tr><tr style='height: 23.25pt;' height='31'><td class='xl68' style='border-top: medium none; height: 23.25pt; text-align: center; font-weight: bold;'>Processing</td><td class='xl69' style='border-top: medium none; border-left: medium none; text-align: center; font-weight: bold;'>1.2.1</td><td class='xl70' style='border-top: medium none; border-left: medium none; text-align: center;'>http://processing.org/</td></tr><tr style='height: 23.25pt;' height='31'><td class='xl68' style='border-top: medium none; height: 23.25pt; text-align: center; font-weight: bold;' height='31'>BioJava</td><td class='xl69' style='border-top: medium none; border-left: medium none; text-align: center; font-weight: bold;'>1.7.1</td><td class='xl70' style='border-top: medium none; border-left: medium none; text-align: center;'>http://biojava.org/wiki/Main_Page</td></tr><tr style='height: 23.25pt;' height='31'><td class='xl68' style='border-top: medium none; height: 23.25pt; text-align: center; font-weight: bold;' height='31'>ReadSeq</td><td class='xl69' style='border-top: medium none; border-left: medium none; text-align: center; font-weight: bold;'>2.1.27</td><td class='xl70' style='border-top: medium none; border-left: medium none; text-align: center;'>http://iubio.bio.indiana.edu/soft/molbio/readseq/java/</td></tr><tr style='height: 23.25pt;' height='31'><td class='xl68' style='border-top: medium none; height: 23.25pt; text-align: center; font-weight: bold;' height='31'>XerialSQLite JDBC Driver</td><td class='xl69' style='border-top: medium none; border-left: medium none; text-align: center; font-weight: bold;'>3.6.20.1</td><td style='border-top: medium none; border-left: medium none; text-align: center;'>http://www.xerial.org/trac/Xerial/wiki/SQLiteJDBC</td></tr></tbody></table><br>\n");
        //--Table header for program
        st.append("<small></small><br><hr style='width: 100%; height: 2px;'><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'>Armadillo includes the following executables in its distribution: </span></span><br><br>"
                + "<table x:str='' style='border-collapse: collapse; width: 1062px; height: 3165px;' border='1' cellpadding='0' cellspacing='0'><col span='7' style='width: 60pt;' width='80'> <tbody><tr><td style='height: 24px; background-color: rgb(153, 153, 153); font-weight: bold; text-align: center; font-style: italic;'>Software</td><td style='height: 24px; background-color: rgb(153, 153, 153); font-weight: bold; text-align: center; font-style: italic;'>Version</td><td style='height: 24px; background-color: rgb(153, 153, 153); font-weight: bold; text-align: center; font-style: italic;'>Type</td><td style='width: 407px; height: 24px; background-color: rgb(153, 153, 153); font-weight: bold; text-align: center; font-style: italic;'>References</td><td style='width: 301px; height: 24px; background-color: rgb(153, 153, 153); font-weight: bold; text-align: center; font-style: italic;' colspan='1' rowspan='1'>Website</td></tr>");
        //--Iterate over all category and create the Table...        
        
        
          
            //--Exceptions (do not put in the report)
                String[] exception_name={"Blast Download","Blast (Web Ncbi)","Create Local BlastDB",
                                         "LocalBlast","dbFetch (Web EBI)","EB-Eye (Web EBI)",
                                         "Ncbi eUtils","Fetch Sequences Ncbi","DNAML-Erate",
                                         "Custom Program _Old_","Kalign - Custom Program"};
                HashMap<String,Boolean> dict_exception_name=new HashMap <String,Boolean>();
                for (String s:exception_name) dict_exception_name.put(s, Boolean.TRUE);
               
                
                for (int i=0; i<treeroot.getChildCount();i++) {
                    ToolboxMutableTreeNode cat=(ToolboxMutableTreeNode) treeroot.getChildAt(i);
                    //--Get applications
                          for (int j=0; j<cat.getChildCount();j++) {                              
                            ToolboxMutableTreeNode appli=(ToolboxMutableTreeNode) cat.getChildAt(j);
                            workflow_properties prop=appli.getProperties();
                            if (!prop.getBoolean("InternalArmadilloApplication")) {
                            
                            try {
                                //st.append("<tr style='height: 12.75pt;' height='17'><br>\n");    
                                st.append("<tr>\n");                                        
                                st.append("<td style='height: 12.75pt; width: 60pt; text-align: center; font-weight: bold;' height='17' width='80'>"+prop.getName()+"</td>\n");
                                st.append("<td style='width: 60pt; text-align: center; font-weight: bold;' width='80'>"+(prop.isSet("Version")?prop.get("Version"):"")+"</td>\n");
                                st.append("<td style='width: 60pt; text-align: center;' width='80'>"+cat.getProperties().getName()+"</td>\n");
                                st.append("<td style='width: 407px;'><small>"+(prop.isSet("Publication")?prop.get("Publication"):"")+"</small></td>\n");
                                st.append("<td rowspan='1' colspan='1' style='width: 301px;'>"+(prop.isSet("Website")?"<a href='"+prop.get("Website")+"'>"+prop.get("Website")+"</a>":""));
                                st.append("</td></tr>\n");    
                                } catch(Exception e) {e.printStackTrace();}
                            }
                         } //--End for
                } //--End for
                st.append("</tbody></table><br><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big style='font-style: italic;'><br> </big></small></span> <hr style='width: 100%; height: 2px;'><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white; font-weight: bold;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'>Supported by grants from:</span></span><br> <span style='font-weight: bold;'></span><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><img style='border: 0px solid ; width: 150px; height: 49px;' alt='' src='uqam.png'></small></span> &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; <img style='width: 200px; height: 89px;' alt='' src='crsng_logo.png'><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><br> </small></span><span style='font-weight: bold;'><small style='color: rgb(102, 102, 102);'><big><big><span style='color: black;'></span></big></big></small></span><hr style='width: 100%; height: 2px;'><span class='Apple-style-span' style='border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium; background-color: white;'><span id='internal-source-marker_0.49239397584460676' style='font-size: 11pt; font-family: Arial; color: rgb(0, 0, 0); font-weight: normal; font-style: normal; text-decoration: none; vertical-align: baseline;'>Licence informations: <span style='font-style: italic;'></span></span></span><div style='background-color: white; color: rgb(102, 102, 102);'><span style='font-weight: bold;'><small>This program is free software: you can redistribute it and/or modify</small></span><br> <span style='font-weight: bold;'><small>it under the terms of the GNU General Public License as published by</small></span><br> <span style='font-weight: bold;'><small>the Free Software Foundation, either version 3 of the License, or</small></span><br> <span style='font-weight: bold;'><small>(at your option) any later version.</small></span><br> <br> <span style='font-weight: bold;'><small>This program is distributed in the hope that it will be useful,</small></span><br> <span style='font-weight: bold;'><small>but WITHOUT ANY WARRANTY; without even the implied warranty of</small></span><br> <span style='font-weight: bold;'><small>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.&nbsp; <br><br>See the </small></span><span style='font-weight: bold;'><small>GNU General Public License for more details.</small></span><br> <br><span style='font-weight: bold;'><small>You should have received a copy of the GNU General Public License</small></span><br> <span style='font-weight: bold;'><small>along with this program.&nbsp; If not, see&lt;<a href='http://www.gnu.org/licenses/'>http://www.gnu.org/licenses/</a>&gt;.</small></span></div></td></tr></tbody></table><span style='font-style: italic; font-weight: bold;'></span></div></div></div><span style='font-weight: bold;'><br></span></body></html> ");
               return st.toString();
         }
    

}
