/*
 *  Armadillo Workflow Platform v1.0
 *  A simple pipeline system for phylogenetic analysis
 *  
 *  Copyright (C) 2009-2011  Etienne Lord, Mickael Leclercq
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


import configuration.Config;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import org.apache.regexp.RE;
import workflows.Workbox;

public class FirstTime_JIternalFrame extends javax.swing.JInternalFrame {

    ////////////////////////////////////////////////////////////////////////////
    /// Variables

    Config config=new Config();
    Frame frame=null;
    Workbox workbox=new Workbox();
    boolean validEmail=false;
    boolean validName=false;
    String default_txt="Armadillo Workflow Platform v1.0\n"+
                        "A simple pipeline system for phylogenetic analysis\n"+
                        "Copyright (C) 2009-2010\n"+
                        "Etienne Lord*, Mickael Leclercq, Alix Boc, Abdoulaye Banire Diallo and Vladimir Makarenkov\n"+
                        "lord.etienne@courrier.uqam.ca\n"+
                        "Université du Québec à Montréal\n\n"+
                        "Press start to create your first workflow.";


    ////////////////////////////////////////////////////////////////////////////
    /// Constructor

    /** Creates new form Welcome */
    public FirstTime_JIternalFrame(Frame frame) {
        initComponents();
        this.setFrameIcon(Config.icon);
        this.setResizable(false);
        this.frame=frame;
        //--Display the Welcome Message
            try {
                //--Default URL
                URL url=new File(config.dataPath()+File.separator+"Documents"+File.separator+"first_time.html").toURL();
                this.URL_JEditorPane.setPage(url);
            } catch (IOException ex) {
                //--Default TXT
                this.URL_JEditorPane.setText(this.default_txt);
            }



        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension d = getSize();
        
        setLocation((screenSize.width-d.width)/2,
					(screenSize.height-d.height)/3);
        setVisible(true);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        StartjButton = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        EmailjTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        InstitutionjTextField = new javax.swing.JTextField();
        NamejTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jStatusMessage = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        URL_JEditorPane = new javax.swing.JEditorPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
        setTitle("Armadillo Workflow Platform v1.0");

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        jPanel1.setMinimumSize(new java.awt.Dimension(100, 100));
        jPanel1.setPreferredSize(new java.awt.Dimension(601, 372));

        StartjButton.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        StartjButton.setText("OK");
        StartjButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StartjButtonActionPerformed(evt);
            }
        });

        jLabel4.setText("Email");

        EmailjTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                EmailjTextFieldFocusLost(evt);
            }
        });
        EmailjTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                EmailjTextFieldKeyTyped(evt);
            }
        });

        jLabel5.setText("Institution");

        InstitutionjTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                InstitutionjTextFieldFocusLost(evt);
            }
        });

        NamejTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                NamejTextFieldFocusLost(evt);
            }
        });
        NamejTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                NamejTextFieldKeyTyped(evt);
            }
        });

        jLabel6.setText("Name");

        jLabel8.setFont(new java.awt.Font("Tahoma", 2, 11));
        jLabel8.setForeground(new java.awt.Color(255, 0, 0));
        jLabel8.setText("(Will be used for the European Bioinformatic Institute (EBI) WebServices)");

        jStatusMessage.setText(" ");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jLabel5)
                        .addComponent(jLabel6))
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jStatusMessage, javax.swing.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(StartjButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(NamejTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
                    .addComponent(InstitutionjTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE)
                    .addComponent(EmailjTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 489, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(NamejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(InstitutionjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(EmailjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jStatusMessage)
                    .addComponent(StartjButton)))
        );

        jScrollPane1.setViewportView(URL_JEditorPane);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, 0, 0, Short.MAX_VALUE)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 580, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 344, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 154, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void StartjButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StartjButtonActionPerformed
        //--Final save
        workbox.getProject().setName(this.NamejTextField.getText());
        workbox.getProject().setInstitution(this.InstitutionjTextField.getText());
        workbox.getProject().setEmail(this.EmailjTextField.getText());
        config.set("email",this.EmailjTextField.getText());
        config.set("author", this.NamejTextField.getText());
        config.set("institution", this.InstitutionjTextField.getText());
        workbox.getProject().updateDatabase();
        config.remove("FirstTime");
        config.Save();
        this.setVisible(false);
    }//GEN-LAST:event_StartjButtonActionPerformed

    private void NamejTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_NamejTextFieldFocusLost
        workbox.getProject().setName(this.NamejTextField.getText());
         if (workbox.getProject().getName().isEmpty()) {
             validName=false;
             MessageError("Warning. Name must not be empty.","");
         } else {
            Message("","");
            validName=true;
         }
//        if (validName&&validEmail) {
//            this.StartjButton.setEnabled(true);
//        } else {
//            this.StartjButton.setEnabled(false);
//        }
    }//GEN-LAST:event_NamejTextFieldFocusLost

    private void InstitutionjTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_InstitutionjTextFieldFocusLost
        workbox.getProject().setInstitution(this.InstitutionjTextField.getText());

    }//GEN-LAST:event_InstitutionjTextFieldFocusLost

    private void EmailjTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_EmailjTextFieldFocusLost
         

    }//GEN-LAST:event_EmailjTextFieldFocusLost

    private void NamejTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_NamejTextFieldKeyTyped
        // TODO add your handling code here:
    }//GEN-LAST:event_NamejTextFieldKeyTyped

    private void EmailjTextFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_EmailjTextFieldKeyTyped
        RE validEmailregex=new RE(".*@.*[.].*");
         if (validEmailregex.match(this.EmailjTextField.getText())) {
            this.EmailjTextField.setForeground(Color.BLACK);
            workbox.getProject().setEmail(this.EmailjTextField.getText());
            config.set("email",this.EmailjTextField.getText());
            this.validEmail=true;
            Message("","");
         } else {
             this.EmailjTextField.setForeground(Color.RED);
             MessageError("Invalid email adress... Must be name@domain.","");
             this.validEmail=false;
         }
//        if (validName&&validEmail) {
//            this.StartjButton.setEnabled(true);
//        } else {
//            this.StartjButton.setEnabled(false);
//        }
    }//GEN-LAST:event_EmailjTextFieldKeyTyped

    ///////////////////////////////////////////////////////////////////////////
    /// MESSAGE FONCTION

    /**
     * Affiche un message dans la status bar
     * La provenance peut être mise dans un tooltip
     * @param text Le texte
     * @param tooltip Le tooltip texte
     */
    void Message(String text, String tooltip) {
        this.jStatusMessage.setEnabled(true);
        this.jStatusMessage.setForeground(new java.awt.Color(0, 51, 153));
        this.jStatusMessage.setBackground(Color.WHITE);
        this.jStatusMessage.setToolTipText(tooltip);
        this.jStatusMessage.setText(text);
    }

    /**
     * Affiche un message d'erreur en rouge dans la status bar
     * La provenance peut être mise dans un tooltip
     * @param text Le texte
     * @param tooltip Le tooltip texte
     */
    void MessageError(String text, String tooltip) {
        this.jStatusMessage.setEnabled(true);
        this.jStatusMessage.setForeground(Color.RED);
        this.jStatusMessage.setBackground(Color.WHITE);
        this.jStatusMessage.setToolTipText(tooltip);
        this.jStatusMessage.setText(text);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField EmailjTextField;
    private javax.swing.JTextField InstitutionjTextField;
    private javax.swing.JTextField NamejTextField;
    private javax.swing.JButton StartjButton;
    private javax.swing.JEditorPane URL_JEditorPane;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel jStatusMessage;
    // End of variables declaration//GEN-END:variables

   

}
