/*
 *  Armadillo Workflow Platform v1.0
 *  A simple pipeline system for phylogenetic analysis
 *  
 *  Copyright (C) 2009-2011  Etienne Lord, Mickael Leclercq
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


import configuration.Config;
import demo.Demo;
import javax.swing.JFrame;
import javax.swing.UIManager;
import splash.SplashWindow;

/**
 * Armadillo v1.0
 *
 * @author Alix Boc, Etienne Lord, Mickael Leclercq, Abdoulaye Baniré Diallo. Vladimir Makarenkov
 * @since May 2009
 *
 */
public class armadillo {

        static MainFrame main;

      ///////////////////////////////////////////////////////////////////////////
      /// MAIN PROGRAM
      /// TO DO: Command-line version to run server, etc.

      public static void main(String args[]) {
         //-- save command arguments
          Config.cmdArgs=args;

        //CASE 1: DEMO Mode? (Development mode)
        if (args.length>0) {
            if (args[0].equalsIgnoreCase("demo")) {
                Demo.RunDemo();
            }  else {
                //--We run a workflow with argument...
                //  Possible cases:
                //  armadillo.jar workflow.db workflow_id [input1] [input2] ...
                //  armadillo.jar workflow.txt [input1] [input2] ...
                Demo.Run();               
            }
        } 
        else
        {
           final SplashWindow splash=new SplashWindow();           
           // CASE 2: Normal GUI Mode
            // OPtionnal : Set look and Feel
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
            } catch (Exception e) {}

            java.awt.EventQueue.invokeLater(new Runnable() {
                public void run() {                   
                
                    main=new MainFrame();
                    splash.setVisible(false);
                    main.setExtendedState(JFrame.MAXIMIZED_BOTH);
                    main.setVisible(true);
                  
                // This don't work
                // main.workbox.mazimizeSize();
                // main.workbox.setWorkflowVisible();
                // main.toolbox.mazimizeSize();
                // main.toolbox.setVisible(true);
                }
            });
            }
    }

}
