package biologic.seqclasses.parserNewick;

import configuration.Util;
import java.io.File;
import java.util.Vector;

/**
 * This parse a newick String indide a Tree-Structure
 *
 * @author Etienne Lord
 */
public class ParserNewickEtienne {


    /**
     * This will create a LaTrans compatible String
     * @param filename_species_tree
     * @param filename_gene_tree
     * @return
     */
    public static String createLatransInputFilename(String filename_species_tree, String filename_gene_tree) {
        newick_tree Tree=new newick_tree();
        newick_tree Tree2=new newick_tree();
        Tree.parseNewick(new File(filename_species_tree));
        Tree2.parseNewick(new File(filename_gene_tree));
        return createLatransInputTree(Tree, Tree2);
    }

    /**
    * This will create a LaTrans compatible String.
    * Note:
    * The format is [species_tree_without_bootstrap: gene_tree_without_bootrap]
    * @return
    */
   public static String createLatransInputTree(newick_tree species_tree, newick_tree gene_tree) {
       StringBuilder st=new StringBuilder();
       st.append("[");
       String species=species_tree.PrintNewickWithoutBranchLength();
       String gene=gene_tree.PrintNewickWithoutBranchLength();
       //==remove ;
       gene=gene.substring(0, gene.length()-1);
       species=species.substring(0, species.length()-1);
       st.append(""+species+": "+gene+"");
       st.append("];");
       return st.toString();
   }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        newick_tree Tree=new newick_tree();
        newick_tree Tree2=new newick_tree();
//        tree Tree3=new tree();
//        tree Tree4=new tree();

        //--Tree Blast
        //Tree.parseNewick("((Zea_mays_clone_1550551_mRNA_sequence:0, ((Oryza_sativa_genomic_DNA__chromosome_4__BAC_clone__OSJNBa0019K04__complete_sequence:0.000690376, (Oryza_sativa__japonica_cultivar_group__Os04g0574700__Os04g0574700__mRNA__complete_cds:0, Oryza_sativa_Japonica_Group_cDNA_clone_001_020_C02__full_insert_sequence:0):0.00127298):0.0435979, (Zea_mays_clone_1535566_mRNA_sequence:0.0215752, Sorghum_bicolor_hypothetical_protein__mRNA:0.014912):0.0251822):0.101551)monocots:0.011022, ((Sorghum_bicolor_hypothetical_protein__mRNA:0.0401998, (((Arabidopsis_thaliana_SLAH3__SLAC1_HOMOLOGUE_3___transporter__SLAH3__mRNA__complete_cds:0, (Arabidopsis_thaliana_At5g24030_gene__complete_cds:0, (Arabidopsis_thaliana_At5g24030_gene__complete_cds:0, Arabidopsis_thaliana_Full_length_cDNA_Complete_sequence_from_clone_GSLTLS54ZA11_of_Adult_vegetative_tissue_of_strain_col_0_of_Arabidopsis_thaliana__thale_cress_:0):0):0):0.110704, ((Arabidopsis_thaliana_SLAH2__SLAC1_HOMOLOGUE_2___transporter__SLAH2__mRNA__complete_cds:0, (Arabidopsis_thaliana_AT4g27970_T13J8_80_mRNA__complete_cds:0, Arabidopsis_thaliana_At4g27970_T13J8_80_mRNA__complete_cds:0):0):0.196788, (Solanum_lycopersicum_cDNA__clone__LEFL2035I19__HTC_in_fruit:0.117892, ((PREDICTED__Vitis_vinifera_hypothetical_protein_LOC100242167__LOC100242167___mRNA:0.000729029, Vitis_vinifera__whole_genome_shotgun_sequence__contig_VV78X196993_13__clone_ENTAV_115:0.0135401):0.0905997, (Ricinus_communis_Tellurite_resistance_protein_tehA__putative__mRNA:0.0736291, Populus_trichocarpa_c4_dicarboxylate_transporter_malic_acid_transport_protein__mRNA:0.0776354):0.0171166):0.00323463):0.0935871):0.0105185)eudicots:0.0522729, (Physcomitrella_patens_subsp__patens_predicted_protein__PHYPADRAFT_41789__mRNA__partial_cds:0.203523, (Physcomitrella_patens_subsp__patens_predicted_protein__PHYPADRAFT_22448__mRNA__partial_cds:0.149312, (Physcomitrella_patens_subsp__patens_predicted_protein__PHYPADRAFT_42715__mRNA__partial_cds:0.216516, ((gi_145335436_ref_NM_101120_3__Arabidopsis_thaliana_OZS1__OZONE_SENSITIVE_1___transporter__OZS1__mRNA__complete_cds:0, (Arabidopsis_thaliana_OZS1__OZONE_SENSITIVE_1___transporter__OZS1__mRNA__complete_cds:0, (Arabidopsis_thaliana_At1g12480_T12C24_4_mRNA__complete_cds:0, (Arabidopsis_thaliana_At1g12480_T12C24_4_gene__complete_cds:0, (Genomic_sequence_for_Arabidopsis_thaliana_BAC_T12C24_from_chromosome_I__complete_sequence:0, Genomic_sequence_for_Arabidopsis_thaliana_BAC_F5O11_from_chromosome_I__complete_sequence:0):0):0):0)eudicots:0):0.127642, ((Medicago_truncatula_clone_mth2_8m7__complete_sequence:0, Medicago_truncatula_chromosome_8_clone_mth2_67l12__complete_sequence:0):0.14925, (Ricinus_communis_Tellurite_resistance_protein_tehA__putative__mRNA:0.127672, (Solanum_lycopersicum_genomic_DNA__chromosome_8__clone__C08HBa0165B06__complete_sequence:0.147227, (PREDICTED__Vitis_vinifera_hypothetical_protein_LOC100244459__LOC100244459___mRNA:0.000987753, Vitis_vinifera__whole_genome_shotgun_sequence__contig_VV78X253597_8__clone_ENTAV_115:0.000424012):0.114969):0.0123037):0.0174491)eudicots:0.0296863):0.0617622):0.0201248):0.0232991):0.0359051):0.0346926):0.00250328, (Sorghum_bicolor_hypothetical_protein__mRNA:0.0153996, (Zea_mays_full_length_cDNA_clone_ZM_BFb0049B01_mRNA__complete_cds:0, Zea_mays_LOC100281575__umc2631___mRNA:0):0.0323873)monocots:0.00176732):0.0126064, ((Zea_mays_clone_EL01N0437C10_d_mRNA_sequence:0.0233984, (Oryza_sativa__japonica_cultivar_group__Os05g0219900__Os05g0219900__mRNA__complete_cds:0, (Oryza_sativa_Japonica_Group_chromosome_5_clone_B1003C08__complete_sequence:0, Oryza_sativa_Japonica_Group_cDNA_clone_J023028P22__full_insert_sequence:0):0):0.0443897):0.0111806, ((Sorghum_bicolor_hypothetical_protein__mRNA:0.0291099, (Zea_mays_clone_1552027_mRNA_sequence:0.0443425, (Oryza_sativa__japonica_cultivar_group__Os01g0226600__Os01g0226600__mRNA__partial_cds:0, (Oryza_sativa_Japonica_Group_cDNA_clone_J023143J08__full_insert_sequence:0, (Oryza_sativa_Japonica_Group_cDNA_clone_J023021A14__full_insert_sequence:0, Oryza_sativa_Japonica_Group_genomic_DNA__chromosome_1__PAC_clone_P0443E07:0):0):0):0.0439948):0.00988619):0.00728776, ((Oryza_sativa_Japonica_Group_genomic_DNA__chromosome_1__PAC_clone_P0501G01:0, (Oryza_sativa_Japonica_Group_cDNA__clone__J065123I09__full_insert_sequence:0, Oryza_sativa__japonica_cultivar_group__Os01g0623200__Os01g0623200__mRNA__complete_cds:0):0.0155261):0.0326951, (Sorghum_bicolor_hypothetical_protein__mRNA:0.0223658, (Sorghum_bicolor_hypothetical_protein__mRNA:0.0383221, ((Sorghum_bicolor_hypothetical_protein__mRNA:0.0275029, Sorghum_bicolor_hypothetical_protein__mRNA:0):0.0504753, (Oryza_sativa__japonica_cultivar_group__Os05g0584900__Os05g0584900__mRNA__complete_cds:0, (Oryza_sativa_Japonica_Group_chromosome_5_clone_OSJNBa0009C07__complete_sequence:0, Oryza_sativa_Japonica_Group_cDNA_clone_001_117_C01__full_insert_sequence:0):0):0.0257632):0.00809336):0.0422534):0.00410958):0.00780112):0.00329398)monocots:0.0197439);");
        Tree.parseNewick(new File("C:\\armadillo2\\trunk\\armadillo\\examples\\Delwiche_and_Palmer_1996_gene_rbcL_40_species_speciestree_rooted.nh"));
        //b Tree.PrintOut();
        

        Tree2.parseNewick(new File("C:\\armadillo2\\trunk\\armadillo\\examples\\Delwiche_and_Palmer_1996_gene_rbcL_40_species_rooted.nh"));
        //b Tree.PrintOut();
        
        Util u=new Util("d:\\latrans.txt");        
        u.println("\n"+createLatransInputTree(Tree,Tree2));
        u.close();


//        //--Test 0;
//        Tree.parseNewick ("((A,C,B),(D,E));");
//        Tree.PrintOut();
//
//        //--Test 1;
//        Tree.parseNewick ("((raccoon:19.19959,bear:6.80041):0.84600[50],dog:25.46154);");
//        Tree.PrintOut();
//        //--Test 2 : source Delwiche and Palmer (1996, gene rbcL, 40 species)
//        Tree2.parseNewick("(Synechocystis:1.0000,(((Prochlorococus:1.0000,((Nitrobacter:1.0000,(Mn_oxidizing:1.0000,(Xanthobacter:1.0000,Rhodobacter_sphI:1.0000):1.0000):1.0000):1.0000,((Pseudomonas:1.0000,(Endosymbiont:1.0000,(Thiobacillus_denI:1.0000,(Alcaligenes_chr2:1.0000,(Alcaligenes_H16_p:1.0000,Alcaligenes_Chr1:1.0000):1.0000):1.0000):1.0000):1.0000):1.0000,(Hydrogenovibrio_L2:1.0000,(Chromatium_L:1.0000,(Thiobacillus_f19859:1.0000,Thiobacillus_fe1:1.0000):1.0000):1.0000):1.0000):1.0000):10.0000):1.0000,(Synechococcus:1.0000,Anabaena:1.0000):1.0000):1.0000,(Prochlorothrix:1.0000,Anacystis:1.0000):1.0000):1.0000,(Prochloron:1.0000,(Cyanophora:1.0000,((Cyanidium:1.0000,((Porphyridium:1.0000,(Ahnfeltia:1.0000,Anthithamnion:1.0000):1.0000):1.0000,(Cryptomonas:1.0000,(Ectocarpus:1.0000,(Olistodiscus:1.0000,Cylindrotheca:1.0000):1.0000):1.0000):1.0000):1.0000):1.0000,(((Chlamidomonas:1.0000,(Euglena:1.0000,Pyramimonas:1.0000):1.0000):1.0000,(Cholrella:1.0000,Bryopsis:1.0000):1.0000):1.0000,(Coleochaete:1.0000,(Marchantia:1.0000,(Pseudotsuga:1.0000,(Nicotiana:1.0000,Oryza:1.0000):1.0000):1.0000):1.0000):1.0000):1.0000):1.0000):1.0000):1.0000);");
//        Tree2.PrintOut();
////
//        //--Test 3 : Matte-Taillez et al (2002, gene rpl12e, 14 species),
//        Tree3.parseNewick("(((A.pernix:1.0,S.solfataricus:1.0):1.0,P.aerophilum:1.0):10.0,(((P.abyssi:1.0,P.horikoshii:1.0):1.0,P.furiosus:1.0):1.0,((M.jannaschii:1.0,M.thermoaut.:1.0):1.0,((T.acidophilum:1.0,F.acidarinanus:1.0):1.0,(((Halobacterium.sp.:1.0,H.marismortui:1.0):1.0,M.barkeri:1.0):1.0,A.fulgidus:1.0):1.0):1.0):1.0):1.0);");
//        Tree3.PrintOut();
//////
//        //--Test 4 : Woese et al (2000, gene pheRS, 32 species)
//        Tree3.parseNewick("((((P.hori:1.0,M.ther:1.0,A.fulg:1.0,M.jann:1.0):1.0,(S.solf:1.0,P.aero:1.0):1.0):1.0,(S.cere:1.0,H.sapi:1.0):1.0):1.0,((B.burg:1.0,T.pall:1.0):1.0,Synech:1.0,C.trac:1.0,(T.ther:1.0,D.radi:1.0):1.0,(N.gono:1.0,H.pilo:1.0,(P.aeru:1.0,E.coli:1.0,H.infl:1.0):1.0,(R.caps:1.0,R.prow:1.0):1.0):1.0,M.tube:1.0,T.mari:1.0,A.aeol:1.0,(P.ging:1.0,C.tepi:1.0):1.0,(C.acet:1.0,(B.subt:1.0,(E.faec:1.0,S.pyog:1.0):1.0):1.0,(M.pneu:1.0,M.geni:1.0):1.0):1.0):1.0);");
//        Tree3.PrintOut();
////
        //--Test 5. long files..
        for (String filename:listTestDir()) {
            if (filename.endsWith(".nw")&&filename.indexOf("big")<0) {
                newick_tree t=new newick_tree();
                t.parseNewick(new File(filename));
                System.out.println(t.ttime);
                t.PrintOut();
            }
        }

    }

    /**
     * List the files in directory for test
     * @return
     */
    public static Vector<String> listTestDir() {
        Vector<String> tmp=new Vector<String>();
        String dir=new File("").getAbsolutePath()+"//test//";
        try {
            File f=new File(dir);
            if (!f.isDirectory()) {
                dir+="//";
                f=new File(dir);
            }
            for (String filename:f.list()) tmp.add(dir+filename);
        } catch(Exception e) {}
        return tmp;
    }


}
