/*
 *  Armadillo Workflow Platform v1.0
 *  A simple pipeline system for phylogenetic analysis
 *  
 *  Copyright (C) 2009-2011  Etienne Lord, Mickael Leclercq
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package editors;



import workflows.Workbox;
import workflows.workflow_properties;
import configuration.Config;
import configuration.ProgramsFilter;
import configuration.Util;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.Robot;
import java.awt.image.BufferedImage;
import java.io.File;
import javax.imageio.ImageIO;
import editor.EditorInterface;
import editor.RenamePropertiesJDialog;
import java.io.File;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import program.programs;
import tools.Toolbox;
import workflows.armadillo_workflow;
import workflows.workflow_properties_dictionnary;

/**
 * Editor of the object properties in the Main Workflow
 * Note: Only called if object doesnt have a Custum Editor
 * @author Etienne Lord
 * @since July 2009
 */
public class CustomEditor extends javax.swing.JDialog implements EditorInterface {

    ////////////////////////////////////////////////////////////////////////////
    /// VARIABLES

    Config config=new Config();
    //ConnectorInfoBox connectorinfobox;
    workflow_properties_dictionnary dict=new workflow_properties_dictionnary();
    String selected="";             // Selected properties
    Frame frame;
    workflow_properties properties;
    armadillo_workflow parent_workflow;
   
    ////////////////////////////////////////////////////////////////////////////
    /// CONSTANT

    public final String defaultNameString=" Name";

    /** Creates new form propertiesJDialog */
    public CustomEditor(java.awt.Frame parent, armadillo_workflow parent_workflow) {
        super(parent, false);
        this.parent_workflow=parent_workflow;
        //--Set variables and init
        frame=parent;     
      
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jComboBox3 = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel9 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        NamejTextField = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jLabel37 = new javax.swing.JLabel();
        ColorModejComboBox = new javax.swing.JComboBox();
        jLabel36 = new javax.swing.JLabel();
        InputNbjComboBox = new javax.swing.JComboBox();
        ConnectorNamejCheckBox1 = new javax.swing.JCheckBox();
        ConnectorjComboBox = new javax.swing.JComboBox();
        ConnectorNamejTextField = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        input1 = new javax.swing.JTextField();
        type1 = new javax.swing.JComboBox();
        input2 = new javax.swing.JTextField();
        type2 = new javax.swing.JComboBox();
        input3 = new javax.swing.JTextField();
        type3 = new javax.swing.JComboBox();
        input4 = new javax.swing.JTextField();
        type4 = new javax.swing.JComboBox();
        input5 = new javax.swing.JTextField();
        type5 = new javax.swing.JComboBox();
        input6 = new javax.swing.JTextField();
        type6 = new javax.swing.JComboBox();
        input7 = new javax.swing.JTextField();
        type7 = new javax.swing.JComboBox();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel7 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        output1 = new javax.swing.JTextField();
        OutputType1 = new javax.swing.JComboBox();
        output2 = new javax.swing.JTextField();
        OutputType2 = new javax.swing.JComboBox();
        output3 = new javax.swing.JTextField();
        OutputType3 = new javax.swing.JComboBox();
        output4 = new javax.swing.JTextField();
        OutputType4 = new javax.swing.JComboBox();
        output5 = new javax.swing.JTextField();
        OutputType5 = new javax.swing.JComboBox();
        output6 = new javax.swing.JTextField();
        OutputType6 = new javax.swing.JComboBox();
        output7 = new javax.swing.JTextField();
        OutputType7 = new javax.swing.JComboBox();
        jLabel11 = new javax.swing.JLabel();
        jSeparator3 = new javax.swing.JSeparator();
        jLabel12 = new javax.swing.JLabel();
        CommandLinejTextField = new javax.swing.JTextField();
        argv1 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        argv2 = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        argv3 = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        argv4 = new javax.swing.JTextField();
        jLabel17 = new javax.swing.JLabel();
        argv8 = new javax.swing.JTextField();
        jLabel18 = new javax.swing.JLabel();
        argv7 = new javax.swing.JTextField();
        jLabel19 = new javax.swing.JLabel();
        argv6 = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        argv5 = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        argv12 = new javax.swing.JTextField();
        jLabel22 = new javax.swing.JLabel();
        argv11 = new javax.swing.JTextField();
        jLabel23 = new javax.swing.JLabel();
        argv10 = new javax.swing.JTextField();
        jLabel24 = new javax.swing.JLabel();
        argv9 = new javax.swing.JTextField();
        jLabel25 = new javax.swing.JLabel();
        argv16 = new javax.swing.JTextField();
        jLabel26 = new javax.swing.JLabel();
        argv15 = new javax.swing.JTextField();
        jLabel27 = new javax.swing.JLabel();
        argv14 = new javax.swing.JTextField();
        jLabel28 = new javax.swing.JLabel();
        argv13 = new javax.swing.JTextField();
        jLabel29 = new javax.swing.JLabel();
        argv20 = new javax.swing.JTextField();
        jLabel30 = new javax.swing.JLabel();
        argv19 = new javax.swing.JTextField();
        jLabel31 = new javax.swing.JLabel();
        argv18 = new javax.swing.JTextField();
        jLabel32 = new javax.swing.JLabel();
        argv17 = new javax.swing.JTextField();
        jLabel33 = new javax.swing.JLabel();
        ProgramjTextField = new javax.swing.JTextField();
        LocatejButton = new javax.swing.JButton();
        refresh_jButton = new javax.swing.JButton();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();
        Port1 = new javax.swing.JComboBox();
        Port2 = new javax.swing.JComboBox();
        Port3 = new javax.swing.JComboBox();
        Port4 = new javax.swing.JComboBox();
        Port5 = new javax.swing.JComboBox();
        Port6 = new javax.swing.JComboBox();
        Port7 = new javax.swing.JComboBox();
        jLabel34 = new javax.swing.JLabel();
        jLabel35 = new javax.swing.JLabel();
        DeleteOutput1 = new javax.swing.JCheckBox();
        DeleteOutput2 = new javax.swing.JCheckBox();
        DeleteOutput3 = new javax.swing.JCheckBox();
        DeleteOutput4 = new javax.swing.JCheckBox();
        DeleteOutput5 = new javax.swing.JCheckBox();
        DeleteOutput6 = new javax.swing.JCheckBox();
        DeleteOutput7 = new javax.swing.JCheckBox();
        DeleteInput7 = new javax.swing.JCheckBox();
        DeleteInput6 = new javax.swing.JCheckBox();
        DeleteInput5 = new javax.swing.JCheckBox();
        DeleteInput4 = new javax.swing.JCheckBox();
        DeleteInput3 = new javax.swing.JCheckBox();
        DeleteInput2 = new javax.swing.JCheckBox();
        DeleteInput1 = new javax.swing.JCheckBox();
        jPanel13 = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jLabel38 = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        VerifyExitValuejCheckBox = new javax.swing.JCheckBox();
        NormalExitValuejTextField = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        ClosejButton = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        jLabel2.setText("jLabel2");

        jTextField3.setText("jTextField1");

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setTitle("Properties");

        jTabbedPane1.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jTabbedPane1ComponentShown(evt);
            }
        });

        jPanel9.setBackground(new java.awt.Color(255, 255, 255));

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        jLabel1.setText("Name");

        NamejTextField.setText(" ");
        NamejTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                NamejTextFieldFocusLost(evt);
            }
        });

        jButton4.setText("Rename");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Visual configuration"));

        jLabel37.setText("Color");

        ColorModejComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "BLUE", "RED", "GREEN", "ORANGE", "PURPLE", "CYAN" }));
        ColorModejComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                ColorModejComboBoxjComboBox4ItemStateChanged(evt);
            }
        });
        ColorModejComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ColorModejComboBoxActionPerformed(evt);
            }
        });

        jLabel36.setText("Number of input");

        InputNbjComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "No Input", "1 Input (default)", "2 Inputs" }));
        InputNbjComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                InputNbjComboBoxItemStateChanged(evt);
            }
        });
        InputNbjComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                InputNbjComboBoxActionPerformed(evt);
            }
        });

        ConnectorNamejCheckBox1.setText("Rename connector");
        ConnectorNamejCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ConnectorNamejCheckBox1ActionPerformed(evt);
            }
        });

        ConnectorjComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Input UP", "Input DOWN", "Output" }));
        ConnectorjComboBox.setToolTipText("");
        ConnectorjComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ConnectorjComboBoxActionPerformed(evt);
            }
        });

        ConnectorNamejTextField.setEnabled(false);
        ConnectorNamejTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                ConnectorNamejTextFieldFocusLost(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(jLabel37)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ColorModejComboBox, 0, 121, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel36)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(InputNbjComboBox, 0, 82, Short.MAX_VALUE)
                .addGap(415, 415, 415))
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(ConnectorNamejCheckBox1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ConnectorjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(ConnectorNamejTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 481, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel37)
                    .addComponent(ColorModejComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel36)
                    .addComponent(InputNbjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ConnectorNamejCheckBox1)
                    .addComponent(ConnectorjComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(ConnectorNamejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        jTextField2.setForeground(java.awt.Color.lightGray);
        jTextField2.setText(" Description");
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });
        jTextField2.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextField2FocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField2FocusLost(evt);
            }
        });
        jTextField2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextField2KeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jTextField2KeyTyped(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jTextField2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 661, Short.MAX_VALUE)
                    .addComponent(NamejTextField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 661, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton4))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(10, 10, 10))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(NamejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(7, 7, 7)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel3.setText("Input");

        jLabel5.setText("(this represent the files that need to be created for the program)");

        jLabel6.setText("Filenames");

        type1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Sequence--", "Sequence - Fasta format - Use sequence name", "Sequence - Fasta format - Use internal sequence id", "Sequence - Fasta format - Use abbreviation", "Sequence - Phylip format - Use sequence name", "Sequence - Phylip format - Use internal sequence id", "Sequence - Phylip format - Use abbreviation", "--MultipleSequences--", "MultipleSequences - Fasta format - Use sequence name", "MultipleSequences - Fasta format - Use internal sequence id", "MultipleSequences - Fasta format - Use abbreviation", "MultipleSequences - Phylip format - Use sequence name", "MultipleSequences - Phylip format - Use internal sequence id", "MultipleSequences - Phylip format - Use abbreviation", "--Alignment--", "Alignment - Fasta format - Use sequence name", "Alignment - Fasta format - Use internal sequence id", "Alignment - Fasta format - Use abbreviation", "Alignment - Phylip format - Use sequence name", "Alignment - Phylip format - Use internal sequence id", "Alignment - Phylip format - Use abbreviation", "--Ancestor--", "Ancestor - Fasta format - Use sequence name", "Ancestor - Fasta format - Use internal sequence id", "Ancestor - Fasta format - Use abbreviation", "Ancestor - Phylip format - Use sequence name", "Ancestor - Phylip format - Use internal sequence id", "Ancestor - Phylip format - Use abbreviation", "--Matrix--", "Matrix", "--Tree--", "Tree - Newick format - Use original tree", "Tree - Newick format - Use sequence_id", "Tree - Newick format - Use abbreviation", "--MultipleTrees--", "MultipleTrees - Newick format - Use original tree", "MultipleTrees - Newick format - Use sequence_id", "MultipleTrees - Newick format - Use abbreviation", "--Phylip--", "Phylip", "Phylip_Distance", "Phylip_Seqboot", "--Results--", "Results text", "--Unknown--", "Unknown", "--Text--", "Text", "--File type (this will not load the file into the database)--", "TextFile", "FastaFile", "SOLIDFile" }));
        type1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                type1ActionPerformed(evt);
            }
        });

        type2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Sequence--", "Sequence - Fasta format - Use sequence name", "Sequence - Fasta format - Use internal sequence id", "Sequence - Fasta format - Use abbreviation", "Sequence - Phylip format - Use sequence name", "Sequence - Phylip format - Use internal sequence id", "Sequence - Phylip format - Use abbreviation", "--MultipleSequences--", "MultipleSequences - Fasta format - Use sequence name", "MultipleSequences - Fasta format - Use internal sequence id", "MultipleSequences - Fasta format - Use abbreviation", "MultipleSequences - Phylip format - Use sequence name", "MultipleSequences - Phylip format - Use internal sequence id", "MultipleSequences - Phylip format - Use abbreviation", "--Alignment--", "Alignment - Fasta format - Use sequence name", "Alignment - Fasta format - Use internal sequence id", "Alignment - Fasta format - Use abbreviation", "Alignment - Phylip format - Use sequence name", "Alignment - Phylip format - Use internal sequence id", "Alignment - Phylip format - Use abbreviation", "--Ancestor--", "Ancestor - Fasta format - Use sequence name", "Ancestor - Fasta format - Use internal sequence id", "Ancestor - Fasta format - Use abbreviation", "Ancestor - Phylip format - Use sequence name", "Ancestor - Phylip format - Use internal sequence id", "Ancestor - Phylip format - Use abbreviation", "--Matrix--", "Matrix", "--Tree--", "Tree - Newick format - Use original tree", "Tree - Newick format - Use sequence_id", "Tree - Newick format - Use abbreviation", "--MultipleTrees--", "MultipleTrees - Newick format - Use original tree", "MultipleTrees - Newick format - Use sequence_id", "MultipleTrees - Newick format - Use abbreviation", "--Phylip--", "Phylip", "Phylip_Distance", "Phylip_Seqboot", "--Results--", "Results text", "--Unknown--", "Unknown", "--Text--", "Text", "--File type (this will not load the file into the database)--", "TextFile", "FastaFile", "SOLIDFile" }));

        type3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Sequence--", "Sequence - Fasta format - Use sequence name", "Sequence - Fasta format - Use internal sequence id", "Sequence - Fasta format - Use abbreviation", "Sequence - Phylip format - Use sequence name", "Sequence - Phylip format - Use internal sequence id", "Sequence - Phylip format - Use abbreviation", "--MultipleSequences--", "MultipleSequences - Fasta format - Use sequence name", "MultipleSequences - Fasta format - Use internal sequence id", "MultipleSequences - Fasta format - Use abbreviation", "MultipleSequences - Phylip format - Use sequence name", "MultipleSequences - Phylip format - Use internal sequence id", "MultipleSequences - Phylip format - Use abbreviation", "--Alignment--", "Alignment - Fasta format - Use sequence name", "Alignment - Fasta format - Use internal sequence id", "Alignment - Fasta format - Use abbreviation", "Alignment - Phylip format - Use sequence name", "Alignment - Phylip format - Use internal sequence id", "Alignment - Phylip format - Use abbreviation", "--Ancestor--", "Ancestor - Fasta format - Use sequence name", "Ancestor - Fasta format - Use internal sequence id", "Ancestor - Fasta format - Use abbreviation", "Ancestor - Phylip format - Use sequence name", "Ancestor - Phylip format - Use internal sequence id", "Ancestor - Phylip format - Use abbreviation", "--Matrix--", "Matrix", "--Tree--", "Tree - Newick format - Use original tree", "Tree - Newick format - Use sequence_id", "Tree - Newick format - Use abbreviation", "--MultipleTrees--", "MultipleTrees - Newick format - Use original tree", "MultipleTrees - Newick format - Use sequence_id", "MultipleTrees - Newick format - Use abbreviation", "--Phylip--", "Phylip", "Phylip_Distance", "Phylip_Seqboot", "--Results--", "Results text", "--Unknown--", "Unknown", "--Text--", "Text", "--File type (this will not load the file into the database)--", "TextFile", "FastaFile", "SOLIDFile" }));

        input4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                input4ActionPerformed(evt);
            }
        });

        type4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Sequence--", "Sequence - Fasta format - Use sequence name", "Sequence - Fasta format - Use internal sequence id", "Sequence - Fasta format - Use abbreviation", "Sequence - Phylip format - Use sequence name", "Sequence - Phylip format - Use internal sequence id", "Sequence - Phylip format - Use abbreviation", "--MultipleSequences--", "MultipleSequences - Fasta format - Use sequence name", "MultipleSequences - Fasta format - Use internal sequence id", "MultipleSequences - Fasta format - Use abbreviation", "MultipleSequences - Phylip format - Use sequence name", "MultipleSequences - Phylip format - Use internal sequence id", "MultipleSequences - Phylip format - Use abbreviation", "--Alignment--", "Alignment - Fasta format - Use sequence name", "Alignment - Fasta format - Use internal sequence id", "Alignment - Fasta format - Use abbreviation", "Alignment - Phylip format - Use sequence name", "Alignment - Phylip format - Use internal sequence id", "Alignment - Phylip format - Use abbreviation", "--Ancestor--", "Ancestor - Fasta format - Use sequence name", "Ancestor - Fasta format - Use internal sequence id", "Ancestor - Fasta format - Use abbreviation", "Ancestor - Phylip format - Use sequence name", "Ancestor - Phylip format - Use internal sequence id", "Ancestor - Phylip format - Use abbreviation", "--Matrix--", "Matrix", "--Tree--", "Tree - Newick format - Use original tree", "Tree - Newick format - Use sequence_id", "Tree - Newick format - Use abbreviation", "--MultipleTrees--", "MultipleTrees - Newick format - Use original tree", "MultipleTrees - Newick format - Use sequence_id", "MultipleTrees - Newick format - Use abbreviation", "--Phylip--", "Phylip", "Phylip_Distance", "Phylip_Seqboot", "--Results--", "Results text", "--Unknown--", "Unknown", "--Text--", "Text", "--File type (this will not load the file into the database)--", "TextFile", "FastaFile", "SOLIDFile" }));

        type5.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Sequence--", "Sequence - Fasta format - Use sequence name", "Sequence - Fasta format - Use internal sequence id", "Sequence - Fasta format - Use abbreviation", "Sequence - Phylip format - Use sequence name", "Sequence - Phylip format - Use internal sequence id", "Sequence - Phylip format - Use abbreviation", "--MultipleSequences--", "MultipleSequences - Fasta format - Use sequence name", "MultipleSequences - Fasta format - Use internal sequence id", "MultipleSequences - Fasta format - Use abbreviation", "MultipleSequences - Phylip format - Use sequence name", "MultipleSequences - Phylip format - Use internal sequence id", "MultipleSequences - Phylip format - Use abbreviation", "--Alignment--", "Alignment - Fasta format - Use sequence name", "Alignment - Fasta format - Use internal sequence id", "Alignment - Fasta format - Use abbreviation", "Alignment - Phylip format - Use sequence name", "Alignment - Phylip format - Use internal sequence id", "Alignment - Phylip format - Use abbreviation", "--Ancestor--", "Ancestor - Fasta format - Use sequence name", "Ancestor - Fasta format - Use internal sequence id", "Ancestor - Fasta format - Use abbreviation", "Ancestor - Phylip format - Use sequence name", "Ancestor - Phylip format - Use internal sequence id", "Ancestor - Phylip format - Use abbreviation", "--Matrix--", "Matrix", "--Tree--", "Tree - Newick format - Use original tree", "Tree - Newick format - Use sequence_id", "Tree - Newick format - Use abbreviation", "--MultipleTrees--", "MultipleTrees - Newick format - Use original tree", "MultipleTrees - Newick format - Use sequence_id", "MultipleTrees - Newick format - Use abbreviation", "--Phylip--", "Phylip", "Phylip_Distance", "Phylip_Seqboot", "--Results--", "Results text", "--Unknown--", "Unknown", "--Text--", "Text", "--File type (this will not load the file into the database)--", "TextFile", "FastaFile", "SOLIDFile" }));

        type6.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Sequence--", "Sequence - Fasta format - Use sequence name", "Sequence - Fasta format - Use internal sequence id", "Sequence - Fasta format - Use abbreviation", "Sequence - Phylip format - Use sequence name", "Sequence - Phylip format - Use internal sequence id", "Sequence - Phylip format - Use abbreviation", "--MultipleSequences--", "MultipleSequences - Fasta format - Use sequence name", "MultipleSequences - Fasta format - Use internal sequence id", "MultipleSequences - Fasta format - Use abbreviation", "MultipleSequences - Phylip format - Use sequence name", "MultipleSequences - Phylip format - Use internal sequence id", "MultipleSequences - Phylip format - Use abbreviation", "--Alignment--", "Alignment - Fasta format - Use sequence name", "Alignment - Fasta format - Use internal sequence id", "Alignment - Fasta format - Use abbreviation", "Alignment - Phylip format - Use sequence name", "Alignment - Phylip format - Use internal sequence id", "Alignment - Phylip format - Use abbreviation", "--Ancestor--", "Ancestor - Fasta format - Use sequence name", "Ancestor - Fasta format - Use internal sequence id", "Ancestor - Fasta format - Use abbreviation", "Ancestor - Phylip format - Use sequence name", "Ancestor - Phylip format - Use internal sequence id", "Ancestor - Phylip format - Use abbreviation", "--Matrix--", "Matrix", "--Tree--", "Tree - Newick format - Use original tree", "Tree - Newick format - Use sequence_id", "Tree - Newick format - Use abbreviation", "--MultipleTrees--", "MultipleTrees - Newick format - Use original tree", "MultipleTrees - Newick format - Use sequence_id", "MultipleTrees - Newick format - Use abbreviation", "--Phylip--", "Phylip", "Phylip_Distance", "Phylip_Seqboot", "--Results--", "Results text", "--Unknown--", "Unknown", "--Text--", "Text", "--File type (this will not load the file into the database)--", "TextFile", "FastaFile", "SOLIDFile" }));

        type7.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "--Sequence--", "Sequence - Fasta format - Use sequence name", "Sequence - Fasta format - Use internal sequence id", "Sequence - Fasta format - Use abbreviation", "Sequence - Phylip format - Use sequence name", "Sequence - Phylip format - Use internal sequence id", "Sequence - Phylip format - Use abbreviation", "--MultipleSequences--", "MultipleSequences - Fasta format - Use sequence name", "MultipleSequences - Fasta format - Use internal sequence id", "MultipleSequences - Fasta format - Use abbreviation", "MultipleSequences - Phylip format - Use sequence name", "MultipleSequences - Phylip format - Use internal sequence id", "MultipleSequences - Phylip format - Use abbreviation", "--Alignment--", "Alignment - Fasta format - Use sequence name", "Alignment - Fasta format - Use internal sequence id", "Alignment - Fasta format - Use abbreviation", "Alignment - Phylip format - Use sequence name", "Alignment - Phylip format - Use internal sequence id", "Alignment - Phylip format - Use abbreviation", "--Ancestor--", "Ancestor - Fasta format - Use sequence name", "Ancestor - Fasta format - Use internal sequence id", "Ancestor - Fasta format - Use abbreviation", "Ancestor - Phylip format - Use sequence name", "Ancestor - Phylip format - Use internal sequence id", "Ancestor - Phylip format - Use abbreviation", "--Matrix--", "Matrix", "--Tree--", "Tree - Newick format - Use original tree", "Tree - Newick format - Use sequence_id", "Tree - Newick format - Use abbreviation", "--MultipleTrees--", "MultipleTrees - Newick format - Use original tree", "MultipleTrees - Newick format - Use sequence_id", "MultipleTrees - Newick format - Use abbreviation", "--Phylip--", "Phylip", "Phylip_Distance", "Phylip_Seqboot", "--Results--", "Results text", "--Unknown--", "Unknown", "--Text--", "Text", "--File type (this will not load the file into the database)--", "TextFile", "FastaFile", "SOLIDFile" }));

        jLabel7.setText("(this represent the files that need to be parsed after the program execution)");

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel4.setText("Output");

        jLabel8.setText("Type");

        jLabel9.setText("Filenames");

        jLabel10.setText("Type");

        OutputType1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Sequence", "MultipleSequences", "Alignment", "Ancestor", "Tree", "MultipleTrees", "Results", "Text", "Matrix", "Unknown", "TextFile", "FastaFile" }));
        OutputType1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OutputType1ActionPerformed(evt);
            }
        });

        OutputType2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Sequence", "MultipleSequences", "Alignment", "Ancestor", "Tree", "MultipleTrees", "Results", "Text", "Matrix", "Unknown", "TextFile", "FastaFile" }));

        OutputType3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Sequence", "MultipleSequences", "Alignment", "Ancestor", "Tree", "MultipleTrees", "Results", "Text", "Matrix", "Unknown", "TextFile", "FastaFile" }));

        OutputType4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Sequence", "MultipleSequences", "Alignment", "Ancestor", "Tree", "MultipleTrees", "Results", "Text", "Matrix", "Unknown", "TextFile", "FastaFile" }));

        OutputType5.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Sequence", "MultipleSequences", "Alignment", "Ancestor", "Tree", "MultipleTrees", "Results", "Text", "Matrix", "Unknown", "TextFile", "FastaFile" }));

        OutputType6.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Sequence", "MultipleSequences", "Alignment", "Ancestor", "Tree", "MultipleTrees", "Results", "Text", "Matrix", "Unknown", "TextFile", "FastaFile" }));

        OutputType7.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Sequence", "MultipleSequences", "Alignment", "Ancestor", "Tree", "MultipleTrees", "Results", "Text", "Matrix", "Unknown", "TextFile", "FastaFile" }));

        jLabel11.setText("(this represent each arguments that will be executed - Press the refresh button for update)");

        jLabel12.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel12.setText("Command Line");

        CommandLinejTextField.setEditable(false);

        jLabel14.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel14.setText("1");

        jLabel15.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel15.setText("2");

        jLabel16.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel16.setText("4");

        jLabel17.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel17.setText("3");

        jLabel18.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel18.setText("8");

        jLabel19.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel19.setText("7");

        jLabel20.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel20.setText("6");

        jLabel21.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel21.setText("5");

        jLabel22.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel22.setText("12");

        jLabel23.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel23.setText("11");

        jLabel24.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel24.setText("10");

        argv9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                argv9ActionPerformed(evt);
            }
        });

        jLabel25.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel25.setText("9");

        jLabel26.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel26.setText("16");

        jLabel27.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel27.setText("15");

        jLabel28.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel28.setText("14");

        argv13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                argv13ActionPerformed(evt);
            }
        });

        jLabel29.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel29.setText("13");

        jLabel30.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel30.setText("20");

        jLabel31.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel31.setText("19");

        jLabel32.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel32.setText("18");

        jLabel33.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel33.setText("17");

        ProgramjTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ProgramjTextFieldActionPerformed(evt);
            }
        });
        ProgramjTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProgramjTextFieldFocusLost(evt);
            }
        });

        LocatejButton.setText("Locate");
        LocatejButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                LocatejButtonActionPerformed(evt);
            }
        });

        refresh_jButton.setBackground(new java.awt.Color(255, 255, 255));
        refresh_jButton.setForeground(new java.awt.Color(255, 255, 255));
        refresh_jButton.setIcon(new javax.swing.ImageIcon(config.imagePath()+"//reload.png"));
        refresh_jButton.setToolTipText("Reload the database");
        refresh_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                refresh_jButtonActionPerformed(evt);
            }
        });

        jCheckBox1.setText("Required");

        jCheckBox2.setText("Required");

        jCheckBox3.setText("Required");

        jCheckBox4.setText("Required");

        jCheckBox5.setText("Required");

        jCheckBox6.setText("Required");

        jCheckBox7.setText("Required");

        Port1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Both", "Up", "Down" }));

        Port2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Both", "Up", "Down" }));

        Port3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Both", "Up", "Down" }));

        Port4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Both", "Up", "Down" }));

        Port5.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Both", "Up", "Down" }));

        Port6.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Both", "Up", "Down" }));

        Port7.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Both", "Up", "Down" }));

        jLabel34.setText("Input Port");

        jLabel35.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel35.setText("Arguments (note: you must separate each one ex. java.exe -jar xyz.jar must be :1 java.exe 2: -jar 3:xyz.jar)");

        DeleteOutput1.setText("Delete file after use");

        DeleteOutput2.setText("Delete file after use");

        DeleteOutput3.setText("Delete file after use");

        DeleteOutput4.setText("Delete file after use");

        DeleteOutput5.setText("Delete file after use");

        DeleteOutput6.setText("Delete file after use");

        DeleteOutput7.setText("Delete file after use");

        DeleteInput7.setText("Delete file after use");

        DeleteInput6.setText("Delete file after use");

        DeleteInput5.setText("Delete file after use");

        DeleteInput4.setText("Delete file after use");

        DeleteInput3.setText("Delete file after use");

        DeleteInput2.setText("Delete file after use");

        DeleteInput1.setText("Delete file after use");

        jPanel13.setBorder(javax.swing.BorderFactory.createTitledBorder("Help"));

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextArea1FocusLost(evt);
            }
        });
        jScrollPane6.setViewportView(jTextArea1);

        jLabel38.setText("Help text or URL (starting with http://)");

        javax.swing.GroupLayout jPanel13Layout = new javax.swing.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addComponent(jLabel38)
                .addContainerGap())
            .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 412, Short.MAX_VALUE)
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addComponent(jLabel38)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 660, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator3, javax.swing.GroupLayout.DEFAULT_SIZE, 822, Short.MAX_VALUE)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 822, Short.MAX_VALUE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel5))
                    .addComponent(jSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 822, Short.MAX_VALUE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(ProgramjTextField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 728, Short.MAX_VALUE)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jLabel12)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel11))
                            .addComponent(CommandLinejTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 728, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(refresh_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(LocatejButton)))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(input1, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel6))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(type1, 0, 297, Short.MAX_VALUE)
                                    .addComponent(jLabel8)))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                    .addComponent(input7, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(type7, 0, 0, Short.MAX_VALUE))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                    .addComponent(input6, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(type6, 0, 0, Short.MAX_VALUE))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                    .addComponent(input5, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(type5, 0, 0, Short.MAX_VALUE))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                    .addComponent(input4, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(type4, 0, 0, Short.MAX_VALUE))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                    .addComponent(input3, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(type3, 0, 0, Short.MAX_VALUE))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel3Layout.createSequentialGroup()
                                    .addComponent(input2, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                    .addComponent(type2, javax.swing.GroupLayout.PREFERRED_SIZE, 291, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Port4, 0, 64, Short.MAX_VALUE)
                            .addComponent(Port5, 0, 64, Short.MAX_VALUE)
                            .addComponent(Port6, 0, 64, Short.MAX_VALUE)
                            .addComponent(Port7, 0, 64, Short.MAX_VALUE)
                            .addComponent(Port3, javax.swing.GroupLayout.Alignment.TRAILING, 0, 64, Short.MAX_VALUE)
                            .addComponent(jLabel34, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(Port2, javax.swing.GroupLayout.Alignment.TRAILING, 0, 64, Short.MAX_VALUE)
                            .addComponent(Port1, 0, 64, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jCheckBox1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeleteInput1))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jCheckBox6)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeleteInput6))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jCheckBox7)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeleteInput7))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jCheckBox5)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeleteInput5))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jCheckBox4)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeleteInput4))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jCheckBox3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeleteInput3))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(jCheckBox2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(DeleteInput2)))
                        .addGap(2, 2, 2))
                    .addComponent(jLabel35)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(output2, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(output3, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(output4, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(output5, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(output6, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(output7, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(OutputType2, 0, 347, Short.MAX_VALUE)
                                    .addComponent(OutputType3, 0, 347, Short.MAX_VALUE)
                                    .addComponent(OutputType4, 0, 347, Short.MAX_VALUE)
                                    .addComponent(OutputType5, 0, 347, Short.MAX_VALUE)
                                    .addComponent(OutputType6, 0, 347, Short.MAX_VALUE)
                                    .addComponent(OutputType7, 0, 347, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(DeleteOutput7)
                                        .addComponent(DeleteOutput6)
                                        .addComponent(DeleteOutput5)
                                        .addComponent(DeleteOutput4)
                                        .addComponent(DeleteOutput3))
                                    .addComponent(DeleteOutput2)))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(output1, javax.swing.GroupLayout.PREFERRED_SIZE, 201, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel9))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel10)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                                        .addComponent(OutputType1, 0, 344, Short.MAX_VALUE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(DeleteOutput1)))))
                        .addGap(105, 105, 105))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv8, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel18))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv9, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel25))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv10, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel24))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv11, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel23))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv12, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel22))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv13, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel29))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv14, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel28))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv15, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel27))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv16, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel26))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv17, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel33))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv18, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel32))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv19, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel31))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv20, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel30))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv1, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel14))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv2, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel15))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv3, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel17))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv4, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel16))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv5, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel21))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv6, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel20))
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(argv7, javax.swing.GroupLayout.PREFERRED_SIZE, 288, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel19)))
                        .addGap(88, 88, 88)
                        .addComponent(jPanel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel8)
                    .addComponent(jLabel34))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(input1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(type1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox1)
                    .addComponent(DeleteInput1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(input2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(type2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox2)
                    .addComponent(DeleteInput2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(input3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(type3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox3)
                    .addComponent(DeleteInput3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(input4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(type4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox4)
                    .addComponent(DeleteInput4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(input5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(type5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox5)
                    .addComponent(DeleteInput5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(input6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(type6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox6)
                    .addComponent(DeleteInput6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(input7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(type7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBox7)
                    .addComponent(DeleteInput7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jLabel10))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(output1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(OutputType1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DeleteOutput1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OutputType2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DeleteOutput2)
                    .addComponent(output2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OutputType3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DeleteOutput3)
                    .addComponent(output3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OutputType4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DeleteOutput4)
                    .addComponent(output4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OutputType5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DeleteOutput5)
                    .addComponent(output5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OutputType6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DeleteOutput6)
                    .addComponent(output6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OutputType7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(DeleteOutput7)
                    .addComponent(output7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(jLabel11))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(refresh_jButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(CommandLinejTextField))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ProgramjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(LocatejButton))
                .addGap(5, 5, 5)
                .addComponent(jLabel35)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel14))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel15))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel17)
                            .addComponent(argv3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel16)
                            .addComponent(argv4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel21))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel20))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel19))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel18))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel25))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel24))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel23))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel22))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel29))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel28))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel27))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel26))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel33))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel32))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv19, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel31))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(argv20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel30)))
                    .addComponent(jPanel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        jScrollPane1.setViewportView(jPanel3);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        VerifyExitValuejCheckBox.setText("Verify program exit value :");
        VerifyExitValuejCheckBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                VerifyExitValuejCheckBoxItemStateChanged(evt);
            }
        });
        VerifyExitValuejCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                VerifyExitValuejCheckBoxActionPerformed(evt);
            }
        });

        NormalExitValuejTextField.setText("0");
        NormalExitValuejTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                NormalExitValuejTextFieldFocusLost(evt);
            }
        });

        jLabel13.setText("(Note: Normal program exit value is 0, but not always. Check Armadillo output)");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(VerifyExitValuejCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(NormalExitValuejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel13)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(VerifyExitValuejCheckBox)
                    .addComponent(NormalExitValuejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        ClosejButton.setText("<html><b>Close</b></html>");
        ClosejButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ClosejButtonActionPerformed(evt);
            }
        });

        jButton5.setText("Run");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jButton8.setText("Stop");
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        jButton6.setText("Reset default values");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jButton1.setText("Save as New Program");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 821, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addComponent(jButton6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 226, Short.MAX_VALUE)
                        .addComponent(jButton8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(ClosejButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 178, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ClosejButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton5)
                    .addComponent(jButton8)
                    .addComponent(jButton1)
                    .addComponent(jButton6))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Custom Application (Beta)", jPanel9);

        jButton3.setText("?");
        jButton3.setToolTipText("Help / Informations");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jButton3)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 815, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 524, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents


    public void createProperties() {
        //ex. Sequence_Name
        //--Input
       properties.put("input1name", this.input1.getText());
       properties.put("input2name", this.input2.getText());
       properties.put("input3name", this.input3.getText());
       properties.put("input4name", this.input4.getText());
       properties.put("input5name", this.input5.getText());
       properties.put("input6name", this.input6.getText());
       properties.put("input7name", this.input7.getText());
              
       properties.put("input1type", (String)this.type1.getSelectedItem());
       properties.put("input2type", (String)this.type2.getSelectedItem());
       properties.put("input3type", (String)this.type3.getSelectedItem());
       properties.put("input4type", (String)this.type4.getSelectedItem());
       properties.put("input5type", (String)this.type5.getSelectedItem());
       properties.put("input6type", (String)this.type6.getSelectedItem());
       properties.put("input7type", (String)this.type7.getSelectedItem());
       properties.put("input1port", (String)this.Port1.getSelectedItem());
       properties.put("input2port", (String)this.Port2.getSelectedItem());
       properties.put("input3port", (String)this.Port3.getSelectedItem());
       properties.put("input4port", (String)this.Port4.getSelectedItem());
       properties.put("input5port", (String)this.Port5.getSelectedItem());
       properties.put("input6port", (String)this.Port6.getSelectedItem());
       properties.put("input7port", (String)this.Port7.getSelectedItem());


       //--Output
       properties.put("output1name", this.output1.getText());
       properties.put("output2name", this.output2.getText());
       properties.put("output3name", this.output3.getText());
       properties.put("output4name", this.output4.getText());
       properties.put("output5name", this.output5.getText());
       properties.put("output6name", this.output6.getText());
       properties.put("output7name", this.output7.getText());
       properties.put("output1type", (String)this.OutputType1.getSelectedItem());
       properties.put("output2type", (String)this.OutputType2.getSelectedItem());
       properties.put("output3type", (String)this.OutputType3.getSelectedItem());
       properties.put("output4type", (String)this.OutputType4.getSelectedItem());
       properties.put("output5type", (String)this.OutputType5.getSelectedItem());
       properties.put("output6type", (String)this.OutputType6.getSelectedItem());
       properties.put("output7type", (String)this.OutputType7.getSelectedItem());
       
       properties.put("execute1", this.argv1.getText());
       properties.put("execute2", this.argv2.getText());
       properties.put("execute3", this.argv3.getText());
       properties.put("execute4", this.argv4.getText());
       properties.put("execute5", this.argv5.getText());
       properties.put("execute6", this.argv6.getText());
       properties.put("execute7", this.argv7.getText());
       properties.put("execute8", this.argv8.getText());
       properties.put("execute9", this.argv9.getText());
       properties.put("execute10", this.argv10.getText());
       properties.put("execute11", this.argv11.getText());
       properties.put("execute12", this.argv12.getText());
       properties.put("execute13", this.argv13.getText());
       properties.put("execute14", this.argv14.getText());
       properties.put("execute15", this.argv15.getText());
       properties.put("execute16", this.argv16.getText());
       properties.put("execute17", this.argv17.getText());
       properties.put("execute18", this.argv18.getText());
       properties.put("execute19", this.argv19.getText());
       properties.put("execute20", this.argv20.getText());

       if (this.jCheckBox1.isSelected()) {
           properties.put("input1required", true);
       } else properties.remove("input1required");

        if (this.jCheckBox2.isSelected()) {
           properties.put("input2required", true);
       } else properties.remove("input2required");

        if (this.jCheckBox3.isSelected()) {
           properties.put("input3required", true);
       } else properties.remove("input3required");

        if (this.jCheckBox4.isSelected()) {
           properties.put("input4required", true);
       } else properties.remove("input4required");

        if (this.jCheckBox5.isSelected()) {
           properties.put("input5required", true);
       } else properties.remove("input5required");

        if (this.jCheckBox6.isSelected()) {
           properties.put("input6required", true);
       } else properties.remove("input6required");

        if (this.jCheckBox7.isSelected()) {
           properties.put("input7required", true);
       } else properties.remove("input7required");
       //--Delete File
        if (this.DeleteInput1.isSelected()) {
           properties.put("input1delete", true);
       } else properties.remove("input1delete");
        if (this.DeleteInput2.isSelected()) {
           properties.put("input2delete", true);
       } else properties.remove("input2delete");
        if (this.DeleteInput3.isSelected()) {
           properties.put("input3delete", true);
       } else properties.remove("input3delete");
        if (this.DeleteInput3.isSelected()) {
           properties.put("input3delete", true);
       } else properties.remove("input3delete");
        if (this.DeleteInput4.isSelected()) {
           properties.put("input4delete", true);
       } else properties.remove("input4delete");
        if (this.DeleteInput5.isSelected()) {
           properties.put("input5delete", true);
       } else properties.remove("input5delete");
       if (this.DeleteInput6.isSelected()) {
           properties.put("input6delete", true);
       } else properties.remove("input6delete");
       if (this.DeleteInput7.isSelected()) {
           properties.put("input7delete", true);
       } else properties.remove("input7delete");
        if (this.DeleteOutput1.isSelected()) {
           properties.put("output1delete", true);
       } else properties.remove("output1delete");
       if (this.DeleteOutput2.isSelected()) {
           properties.put("output2delete", true);
       } else properties.remove("output2delete");
       if (this.DeleteOutput3.isSelected()) {
           properties.put("output3delete", true);
       } else properties.remove("output3delete");
       if (this.DeleteOutput4.isSelected()) {
           properties.put("output4delete", true);
       } else properties.remove("output4delete");
       if (this.DeleteOutput5.isSelected()) {
           properties.put("output5delete", true);
       } else properties.remove("output5delete");
       if (this.DeleteOutput6.isSelected()) {
           properties.put("output6delete", true);
       } else properties.remove("output6delete");
       if (this.DeleteOutput7.isSelected()) {
           properties.put("output7delete", true);
       } else properties.remove("output7delete");


    }

    private void ClosejButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ClosejButtonActionPerformed
       createProperties();
        //-- 2. Close dialog
       this.parent_workflow.redraw();
        this.setVisible(false);
}//GEN-LAST:event_ClosejButtonActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        HelpEditor help = new HelpEditor(this.frame, false, properties.get("Name"), properties.get("help"));
        help.setVisible(true);
}//GEN-LAST:event_jButton3ActionPerformed

    private void jTabbedPane1ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jTabbedPane1ComponentShown

}//GEN-LAST:event_jTabbedPane1ComponentShown

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        properties.put("Name", this.NamejTextField.getText());
        parent_workflow.updateCurrentWorkflow(properties);
}//GEN-LAST:event_jButton4ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        properties.load();             //--reload current properties from file
        this.setProperties(properties);//--Update current field
}//GEN-LAST:event_jButton6ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        properties.put("Status", Config.status_nothing);
        properties.killThread();
}//GEN-LAST:event_jButton8ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
       if(properties.isSet("ClassName")) {
           this.parent_workflow.workflow.updateDependance();
           programs prog=new programs(parent_workflow.workbox.getCurrentWorkflows());
           prog.Run(properties);
        }
    }//GEN-LAST:event_jButton5ActionPerformed

    private void argv9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_argv9ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_argv9ActionPerformed

    private void argv13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_argv13ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_argv13ActionPerformed

    private void input4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_input4ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_input4ActionPerformed

    private void type1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_type1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_type1ActionPerformed

    private void ProgramjTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProgramjTextFieldFocusLost

}//GEN-LAST:event_ProgramjTextFieldFocusLost

    private void LocatejButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_LocatejButtonActionPerformed
        JFileChooser jf=new JFileChooser("Executable"+File.separator);
        jf.addChoosableFileFilter(new ProgramsFilter());
        jf.setAcceptAllFileFilterUsed(false);
        jf.setName("Locate program Executable ...");
        int result=jf.showOpenDialog(this);
        if (result==JFileChooser.APPROVE_OPTION) {
            String filename=jf.getSelectedFile().getName();
            String path=jf.getSelectedFile().getAbsolutePath();
            if (path.indexOf("executable")>-1) {
                path=path.substring(path.indexOf("executable"),path.length());
            }            
            properties.setExecutable(path);
            this.ProgramjTextField.setText(path);

        }
}//GEN-LAST:event_LocatejButtonActionPerformed

    private void ProgramjTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ProgramjTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ProgramjTextFieldActionPerformed

    private void refresh_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_refresh_jButtonActionPerformed
        //--Set the correct information into the properties
        this.createProperties();
        //--Generate command line
        String commandLine=properties.getExecutable();
        for (int i=1; i<21;i++) commandLine+=(properties.isSet("execute"+i)?" "+properties.get("execute"+i):"");
        this.CommandLinejTextField.setText(commandLine);
        this.properties.setCommandline(commandLine);
}//GEN-LAST:event_refresh_jButtonActionPerformed

    private void VerifyExitValuejCheckBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_VerifyExitValuejCheckBoxItemStateChanged
        properties.put("VerifyExitValue",VerifyExitValuejCheckBox.isSelected());
        //--Update View
        this.NormalExitValuejTextField.setEnabled(properties.getBoolean("VerifyExitValue"));
}//GEN-LAST:event_VerifyExitValuejCheckBoxItemStateChanged

    private void VerifyExitValuejCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_VerifyExitValuejCheckBoxActionPerformed
        properties.put("VerifyExitValue",VerifyExitValuejCheckBox.isSelected());
        //--Update View
        this.NormalExitValuejTextField.setEnabled(properties.getBoolean("VerifyExitValue"));
}//GEN-LAST:event_VerifyExitValuejCheckBoxActionPerformed

    private void NormalExitValuejTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_NormalExitValuejTextFieldFocusLost
        int value=0;
        try {
            value=Integer.valueOf(this.NormalExitValuejTextField.getText());
        } catch(Exception e) {value=0;}
        properties.put("NormalExitValue", value);
}//GEN-LAST:event_NormalExitValuejTextFieldFocusLost

    private void OutputType1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OutputType1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_OutputType1ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        String name="Your Program.properties";
        RenamePropertiesJDialog rp=new RenamePropertiesJDialog(frame, name,"Create New Properties");
        rp.Message("Note: This is the filename which will be in your data/properties path","");
        rp.setVisible(true);
            if (!rp.propertiesName.equals("")) {
                String filename=rp.propertiesName;                
                properties.remove("ObjectID");
                properties.save(filename, config.get("propertiesPath"));
            }            
            Workbox.toolbox.reloadToolTree();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void ConnectorjComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ConnectorjComboBoxActionPerformed
        int i=this.ConnectorjComboBox.getSelectedIndex();
        int index =0;
        switch (i) {
            //--Port UP
            case 0: index=3;break;
            
            //--Port DOWN
            case 1: index=2; break;

            //--Port Output
            case 2: index=0;break;
            
        }
        String keyOutput="Connector"+index+"Output";
        String keyConditional="Connector"+index+"Conditional";
        String keyConnectorName="Connector"+index;        

        this.ConnectorNamejCheckBox1.setSelected(properties.isSet(keyConnectorName));
        this.ConnectorNamejTextField.setEnabled(properties.isSet(keyConnectorName));
        if (properties.isSet(keyConnectorName)) {
            this.ConnectorNamejTextField.setText(properties.get(keyConnectorName));
        } else {
            this.ConnectorNamejTextField.setText("");
        }
}//GEN-LAST:event_ConnectorjComboBoxActionPerformed

    private void ConnectorNamejCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ConnectorNamejCheckBox1ActionPerformed
        int i=this.ConnectorjComboBox.getSelectedIndex();
        int index =0;
        switch (i) {
            //--Port UP
            case 0: index=3;break;

            //--Port DOWN
            case 1: index=2; break;

            //--Port Output
            case 2: index=0;break;

        }
        String keyConnectorName="Connector"+index;
        if (this.ConnectorNamejCheckBox1.isSelected()) {
            this.ConnectorNamejTextField.setEnabled(true);
            if (properties.isSet(keyConnectorName)) this.ConnectorNamejTextField.setText(properties.get(keyConnectorName));
        } else {
            properties.remove(keyConnectorName);
            this.ConnectorNamejTextField.setEnabled(false);
        }
}//GEN-LAST:event_ConnectorNamejCheckBox1ActionPerformed

    private void ConnectorNamejTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ConnectorNamejTextFieldFocusLost
       int i=this.ConnectorjComboBox.getSelectedIndex();
        int index =0;
        switch (i) {
            //--Port UP
            case 0: index=3;break;

            //--Port DOWN
            case 1: index=2; break;

            //--Port Output
            case 2: index=0;break;

        }
        String keyConnectorName="Connector"+index;
        if (this.ConnectorNamejCheckBox1.isSelected()) {
            properties.put(keyConnectorName,this.ConnectorNamejTextField.getText());
        }
}//GEN-LAST:event_ConnectorNamejTextFieldFocusLost

    private void InputNbjComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_InputNbjComboBoxItemStateChanged
          
}//GEN-LAST:event_InputNbjComboBoxItemStateChanged

    private void ColorModejComboBoxjComboBox4ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_ColorModejComboBoxjComboBox4ItemStateChanged
       
        
}//GEN-LAST:event_ColorModejComboBoxjComboBox4ItemStateChanged

    private void ColorModejComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ColorModejComboBoxActionPerformed
      String color=(String)ColorModejComboBox.getSelectedItem();
        properties.put("defaultColor", color);       
       //parent_workflow.updateWorkflow(properties);

}//GEN-LAST:event_ColorModejComboBoxActionPerformed

    private void InputNbjComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_InputNbjComboBoxActionPerformed
       Integer nbinput=this.InputNbjComboBox.getSelectedIndex();
        properties.put("nbInput", nbinput.toString());
        //parent_workflow.updateWorkflow(properties);
    }//GEN-LAST:event_InputNbjComboBoxActionPerformed

    private void jTextArea1FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextArea1FocusLost
        properties.put("help", this.jTextArea1.getText());
}//GEN-LAST:event_jTextArea1FocusLost

    private void NamejTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_NamejTextFieldFocusLost
        properties.put("Name", this.NamejTextField.getText());
        parent_workflow.updateCurrentWorkflow(properties);
    }//GEN-LAST:event_NamejTextFieldFocusLost

    private void jTextField2FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField2FocusGained
        if (jTextField2.getText().equals("Description")) {
            jTextField2.setText("");
            jTextField2.setForeground(Color.BLACK);
        } // TODO add your handling code here:
}//GEN-LAST:event_jTextField2FocusGained

    private void jTextField2FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField2FocusLost
        if (jTextField2.getText().trim().equals("")) {
            this.jTextField2.setText("Description");
            this.jTextField2.setForeground(Color.LIGHT_GRAY);
        } else {
            String description=this.jTextField2.getText();
            properties.put("Description", description.trim());
            
        }
}//GEN-LAST:event_jTextField2FocusLost

    private void jTextField2KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField2KeyPressed
        // TODO add your handling code here:
}//GEN-LAST:event_jTextField2KeyPressed

    private void jTextField2KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField2KeyTyped
        String description=this.jTextField2.getText();
        properties.put("Description", description.trim());
        
}//GEN-LAST:event_jTextField2KeyTyped

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField2ActionPerformed

   
    /**
     * This set the Properties
     * @param properties
     */
    public void setProperties(workflow_properties properties) {
        this.properties=properties;
        setTitle(properties.getName());       
        this.NamejTextField.setText(properties.getName());
        this.jTabbedPane1.setTitleAt(0, properties.getName());
        //--Input
        if (properties.isSet("input1name")) this.input1.setText(properties.get("input1name")); //--Filename
        if (properties.isSet("input2name")) this.input2.setText(properties.get("input2name"));
        if (properties.isSet("input3name")) this.input3.setText(properties.get("input3name"));
        if (properties.isSet("input4name")) this.input4.setText(properties.get("input4name"));
        if (properties.isSet("input5name")) this.input5.setText(properties.get("input5name"));
        if (properties.isSet("input6name")) this.input6.setText(properties.get("input6name"));
        if (properties.isSet("input7name")) this.input7.setText(properties.get("input7name"));
        if (properties.isSet("input1type")) this.type1.setSelectedItem(properties.get("input1type"));
        if (properties.isSet("input2type")) this.type2.setSelectedItem(properties.get("input2type"));
        if (properties.isSet("input3type")) this.type3.setSelectedItem(properties.get("input3type"));
        if (properties.isSet("input4type")) this.type4.setSelectedItem(properties.get("input4type"));
        if (properties.isSet("input5type")) this.type5.setSelectedItem(properties.get("input5type"));
        if (properties.isSet("input6type")) this.type6.setSelectedItem(properties.get("input6type"));
        if (properties.isSet("input7type")) this.type7.setSelectedItem(properties.get("input7type"));
        this.jCheckBox1.setSelected(properties.getBoolean("input1required")); //--Requiredment
        this.jCheckBox2.setSelected(properties.getBoolean("input2required"));
        this.jCheckBox3.setSelected(properties.getBoolean("input3required"));
        this.jCheckBox4.setSelected(properties.getBoolean("input4required"));
        this.jCheckBox5.setSelected(properties.getBoolean("input5required"));
        this.jCheckBox6.setSelected(properties.getBoolean("input6required"));
        this.jCheckBox7.setSelected(properties.getBoolean("input7required"));

        this.DeleteInput1.setSelected(properties.getBoolean("input1delete")); //--Delete
        this.DeleteInput2.setSelected(properties.getBoolean("input2delete"));
        this.DeleteInput3.setSelected(properties.getBoolean("input3delete"));
        this.DeleteInput4.setSelected(properties.getBoolean("input4delete"));
        this.DeleteInput5.setSelected(properties.getBoolean("input5delete"));
        this.DeleteInput6.setSelected(properties.getBoolean("input6delete"));
        this.DeleteInput7.setSelected(properties.getBoolean("input7delete"));
        
        this.DeleteOutput1.setSelected(properties.getBoolean("output1delete")); //--Delete
        this.DeleteOutput2.setSelected(properties.getBoolean("output2delete")); //--Delete
        this.DeleteOutput3.setSelected(properties.getBoolean("output3delete")); //--Deletet
        this.DeleteOutput4.setSelected(properties.getBoolean("output4delete")); //--Delete
        this.DeleteOutput5.setSelected(properties.getBoolean("output5delete")); //--Delete
        this.DeleteOutput6.setSelected(properties.getBoolean("output6delete")); //--Delete
        this.DeleteOutput7.setSelected(properties.getBoolean("output7delete")); //--Delete


        if (properties.isSet("input1port")) this.Port1.setSelectedItem(properties.get("input1port")); //--Port
        if (properties.isSet("input2port")) this.Port2.setSelectedItem(properties.get("input2port"));
        if (properties.isSet("input3port")) this.Port3.setSelectedItem(properties.get("input3port"));
        if (properties.isSet("input4port")) this.Port4.setSelectedItem(properties.get("input4port"));
        if (properties.isSet("input5port")) this.Port5.setSelectedItem(properties.get("input5port"));
        if (properties.isSet("input6port")) this.Port6.setSelectedItem(properties.get("input6port"));
        if (properties.isSet("input7port")) this.Port7.setSelectedItem(properties.get("input7port"));


        //--Output
        if (properties.isSet("output1name")) this.output1.setText(properties.get("output1name")); //--Filename
        if (properties.isSet("output2name")) this.output2.setText(properties.get("output2name")); 
        if (properties.isSet("output3name")) this.output3.setText(properties.get("output3name")); 
        if (properties.isSet("output4name")) this.output4.setText(properties.get("output4name")); 
        if (properties.isSet("output5name")) this.output5.setText(properties.get("output5name")); 
        if (properties.isSet("output6name")) this.output6.setText(properties.get("output6name")); 
        if (properties.isSet("output7name")) this.output7.setText(properties.get("output7name")); 
        if (properties.isSet("output1type")) this.OutputType1.setSelectedItem(properties.get("output1type"));
        if (properties.isSet("output2type")) this.OutputType2.setSelectedItem(properties.get("output2type"));
        if (properties.isSet("output3type")) this.OutputType3.setSelectedItem(properties.get("output3type"));
        if (properties.isSet("output4type")) this.OutputType4.setSelectedItem(properties.get("output4type"));
        if (properties.isSet("output5type")) this.OutputType5.setSelectedItem(properties.get("output5type"));
        if (properties.isSet("output6type")) this.OutputType6.setSelectedItem(properties.get("output6type"));
        if (properties.isSet("output7type")) this.OutputType7.setSelectedItem(properties.get("output7type"));
        //--Executable 
        this.ProgramjTextField.setText(properties.getExecutable());
        if (properties.isSet("execute1")) this.argv1.setText(properties.get("execute1"));
        if (properties.isSet("execute2")) this.argv2.setText(properties.get("execute2"));
        if (properties.isSet("execute3")) this.argv3.setText(properties.get("execute3"));
        if (properties.isSet("execute4")) this.argv4.setText(properties.get("execute4"));
        if (properties.isSet("execute5")) this.argv5.setText(properties.get("execute5"));
        if (properties.isSet("execute6")) this.argv6.setText(properties.get("execute6"));
        if (properties.isSet("execute7")) this.argv7.setText(properties.get("execute7"));
        if (properties.isSet("execute8")) this.argv8.setText(properties.get("execute8"));
        if (properties.isSet("execute9")) this.argv9.setText(properties.get("execute9"));
        if (properties.isSet("execute10")) this.argv10.setText(properties.get("execute10"));
        if (properties.isSet("execute11")) this.argv11.setText(properties.get("execute11"));
        if (properties.isSet("execute12")) this.argv12.setText(properties.get("execute12"));
        if (properties.isSet("execute13")) this.argv13.setText(properties.get("execute13"));
        if (properties.isSet("execute14")) this.argv14.setText(properties.get("execute14"));
        if (properties.isSet("execute15")) this.argv15.setText(properties.get("execute15"));
        if (properties.isSet("execute16")) this.argv16.setText(properties.get("execute16"));
        if (properties.isSet("execute17")) this.argv17.setText(properties.get("execute17"));
        if (properties.isSet("execute18")) this.argv18.setText(properties.get("execute18"));
        if (properties.isSet("execute19")) this.argv19.setText(properties.get("execute19"));
        if (properties.isSet("execute20")) this.argv20.setText(properties.get("execute20"));
        this.VerifyExitValuejCheckBox.setSelected(properties.getBoolean("VerifyExitValue"));

               int i=this.ConnectorjComboBox.getSelectedIndex();
                int index =0;
                switch (i) {
                    //--Port UP
                    case 0: index=3;break;

                    //--Port DOWN
                    case 1: index=2; break;

                    //--Port Output
                    case 2: index=0;break;

                }
                String keyOutput="Connector"+index+"Output";
                String keyConditional="Connector"+index+"Conditional";
                String keyConnectorName="Connector"+index;
                this.ConnectorNamejCheckBox1.setSelected(properties.isSet(keyConnectorName));
                this.ConnectorNamejTextField.setEnabled(properties.isSet(keyConnectorName));
                if (properties.isSet(keyConnectorName)) {
                    this.ConnectorNamejTextField.setText(properties.get(keyConnectorName));
                } else {
                    this.ConnectorNamejTextField.setText("");
                }
        
      
                
        //--Color
            index=Util.indexOf(properties.get("defaultColor"), workflow_properties_dictionnary.colorMode);
            if (index>-1) this.ColorModejComboBox.setSelectedIndex(index);
        //--InputNb
            InputNbjComboBox.setSelectedIndex(properties.getInt("nbInput"));
    }


    ///////////////////////////////////////////////////////////////////////////
    /// DISPLAY MAIN FUNCTION

    public void display(workflow_properties properties) {
        initComponents();               
        setIconImage(Config.image);
       this.setProperties(properties);
        // Set position 
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension d = getSize();
        setLocation((screenSize.width-d.width)/2,
					(screenSize.height-d.height)/2);        
        this.setAlwaysOnTop(true);
        this.setVisible(true);
    }

   public void saveImage(String filename) {
        BufferedImage bi;
        try {
            bi = new Robot().createScreenCapture(this.getBounds()); 
            ImageIO.write(bi, "png", new File(filename));
            this.setVisible(false);            
        } catch (Exception ex) {
           Config.log("Unable to save "+filename+" dialog image");
        }            
    }


    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton ClosejButton;
    private javax.swing.JComboBox ColorModejComboBox;
    private javax.swing.JTextField CommandLinejTextField;
    private javax.swing.JCheckBox ConnectorNamejCheckBox1;
    private javax.swing.JTextField ConnectorNamejTextField;
    private javax.swing.JComboBox ConnectorjComboBox;
    private javax.swing.JCheckBox DeleteInput1;
    private javax.swing.JCheckBox DeleteInput2;
    private javax.swing.JCheckBox DeleteInput3;
    private javax.swing.JCheckBox DeleteInput4;
    private javax.swing.JCheckBox DeleteInput5;
    private javax.swing.JCheckBox DeleteInput6;
    private javax.swing.JCheckBox DeleteInput7;
    private javax.swing.JCheckBox DeleteOutput1;
    private javax.swing.JCheckBox DeleteOutput2;
    private javax.swing.JCheckBox DeleteOutput3;
    private javax.swing.JCheckBox DeleteOutput4;
    private javax.swing.JCheckBox DeleteOutput5;
    private javax.swing.JCheckBox DeleteOutput6;
    private javax.swing.JCheckBox DeleteOutput7;
    private javax.swing.JComboBox InputNbjComboBox;
    private javax.swing.JButton LocatejButton;
    private javax.swing.JTextField NamejTextField;
    private javax.swing.JTextField NormalExitValuejTextField;
    private javax.swing.JComboBox OutputType1;
    private javax.swing.JComboBox OutputType2;
    private javax.swing.JComboBox OutputType3;
    private javax.swing.JComboBox OutputType4;
    private javax.swing.JComboBox OutputType5;
    private javax.swing.JComboBox OutputType6;
    private javax.swing.JComboBox OutputType7;
    private javax.swing.JComboBox Port1;
    private javax.swing.JComboBox Port2;
    private javax.swing.JComboBox Port3;
    private javax.swing.JComboBox Port4;
    private javax.swing.JComboBox Port5;
    private javax.swing.JComboBox Port6;
    private javax.swing.JComboBox Port7;
    private javax.swing.JTextField ProgramjTextField;
    private javax.swing.JCheckBox VerifyExitValuejCheckBox;
    private javax.swing.JTextField argv1;
    private javax.swing.JTextField argv10;
    private javax.swing.JTextField argv11;
    private javax.swing.JTextField argv12;
    private javax.swing.JTextField argv13;
    private javax.swing.JTextField argv14;
    private javax.swing.JTextField argv15;
    private javax.swing.JTextField argv16;
    private javax.swing.JTextField argv17;
    private javax.swing.JTextField argv18;
    private javax.swing.JTextField argv19;
    private javax.swing.JTextField argv2;
    private javax.swing.JTextField argv20;
    private javax.swing.JTextField argv3;
    private javax.swing.JTextField argv4;
    private javax.swing.JTextField argv5;
    private javax.swing.JTextField argv6;
    private javax.swing.JTextField argv7;
    private javax.swing.JTextField argv8;
    private javax.swing.JTextField argv9;
    private javax.swing.JTextField input1;
    private javax.swing.JTextField input2;
    private javax.swing.JTextField input3;
    private javax.swing.JTextField input4;
    private javax.swing.JTextField input5;
    private javax.swing.JTextField input6;
    private javax.swing.JTextField input7;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton8;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField output1;
    private javax.swing.JTextField output2;
    private javax.swing.JTextField output3;
    private javax.swing.JTextField output4;
    private javax.swing.JTextField output5;
    private javax.swing.JTextField output6;
    private javax.swing.JTextField output7;
    private javax.swing.JButton refresh_jButton;
    private javax.swing.JComboBox type1;
    private javax.swing.JComboBox type2;
    private javax.swing.JComboBox type3;
    private javax.swing.JComboBox type4;
    private javax.swing.JComboBox type5;
    private javax.swing.JComboBox type6;
    private javax.swing.JComboBox type7;
    // End of variables declaration//GEN-END:variables



}
