/*
 *  Armadillo Workflow Platform v1.0
 *  A simple pipeline system for phylogenetic analysis
 *  
 *  Copyright (C) 2009-2011  Etienne Lord, Mickael Leclercq
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package workflows;

import biologic.seqclasses.InformationJDialog;
import biologic.Workflows;
import configuration.Config;
import configuration.Util;
import database.databaseFunction;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.List;
import javax.swing.SwingWorker;
import tools.Toolbox;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Etienne Lord
 */
public class WorkFlowPreferenceJDialog extends javax.swing.JDialog {

    Workbox workbox=new Workbox();
    Toolbox toolbox=new Toolbox();
    Config config=new Config();
  
    databaseFunction df=new databaseFunction();
    boolean modified=false;             //--Flag to know if something was modified
    Workflows work;
    Frame frame;
    public static InformationJDialog loading;

    /** Creates new form WorkFlowPreferenceJDialog */
    public WorkFlowPreferenceJDialog(java.awt.Frame parent) {
        super(parent, false);
        frame=parent;
        initComponents();
        //--Closing this windows
        addWindowListener(new WindowAdapter() {
            @Override
        public void windowClosing(WindowEvent we) {
            //--Don't update if closing windows
            // updateInformations();
            setVisible(false);
        }
        });
        setTitle("Project and current workflow preferences");
        Message("","");
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension d = getSize();
        setLocation((screenSize.width-d.width)/2,
					(screenSize.height-d.height)/2);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel5 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        ProjectNamejTextField = new javax.swing.JTextField();
        jScrollPane2 = new javax.swing.JScrollPane();
        ProjectNotejTextArea = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        ProjectAuthorjTextField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        ProjectInstitutionjTextField = new javax.swing.JTextField();
        ProjectEmailjTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jStatusMessage = new javax.swing.JTextField();
        jPanel6 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        workflow_name_JTextfield = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        Note_jTextArea = new javax.swing.JTextArea();
        IdentificationjLabel = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        CreatedjLabel = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jCheckBox4 = new javax.swing.JCheckBox();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();
        jCheckBox8 = new javax.swing.JCheckBox();
        jPanel9 = new javax.swing.JPanel();
        Separator_jComboBox2 = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        Separator_jComboBox3 = new javax.swing.JComboBox();
        jLabel8 = new javax.swing.JLabel();
        SimpleGraphjCheckBox = new javax.swing.JCheckBox();
        ShowGridjCheckBox = new javax.swing.JCheckBox();
        jLabel9 = new javax.swing.JLabel();
        LowResolutionCheckBox = new javax.swing.JCheckBox();
        fontsize_jComboBox4 = new javax.swing.JComboBox();
        jLabel13 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        Memory_jComboBox4 = new javax.swing.JComboBox();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        ClosejButton = new javax.swing.JButton();
        CanceljButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);

        jPanel5.setBackground(new java.awt.Color(255, 255, 255));

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));
        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Project Identification"));

        jLabel6.setText("Name");

        ProjectNamejTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProjectNamejTextFieldFocusLost(evt);
            }
        });

        ProjectNotejTextArea.setColumns(20);
        ProjectNotejTextArea.setRows(5);
        ProjectNotejTextArea.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProjectNotejTextAreaFocusLost(evt);
            }
        });
        jScrollPane2.setViewportView(ProjectNotejTextArea);

        jLabel1.setText("Description");

        jLabel2.setText("Author");

        ProjectAuthorjTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProjectAuthorjTextFieldFocusLost(evt);
            }
        });

        jLabel7.setText("Institution");

        ProjectInstitutionjTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProjectInstitutionjTextFieldFocusLost(evt);
            }
        });

        ProjectEmailjTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                ProjectEmailjTextFieldFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                ProjectEmailjTextFieldFocusLost(evt);
            }
        });

        jLabel3.setText("Email");

        jStatusMessage.setBorder(null);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 511, Short.MAX_VALUE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(82, 82, 82)
                        .addComponent(jStatusMessage, javax.swing.GroupLayout.DEFAULT_SIZE, 449, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel7)
                            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addGroup(jPanel4Layout.createSequentialGroup()
                                    .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(jLabel6)
                                        .addComponent(jLabel3))
                                    .addGap(10, 10, 10))
                                .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(ProjectAuthorjTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)
                            .addComponent(ProjectNamejTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)
                            .addComponent(ProjectEmailjTextField, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)
                            .addComponent(ProjectInstitutionjTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1)))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(ProjectNamejTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ProjectAuthorjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel3)
                    .addComponent(ProjectEmailjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ProjectInstitutionjTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 211, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jStatusMessage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Project", jPanel5);

        jPanel6.setBackground(new java.awt.Color(255, 255, 255));

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        workflow_name_JTextfield.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                workflow_name_JTextfieldFocusLost(evt);
            }
        });

        Note_jTextArea.setColumns(20);
        Note_jTextArea.setRows(5);
        Note_jTextArea.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                Note_jTextAreaFocusLost(evt);
            }
        });
        jScrollPane1.setViewportView(Note_jTextArea);

        IdentificationjLabel.setText("Current Workflow identification");

        jLabel4.setText("Note");

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Creation", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Lucida Grande", 0, 13), new java.awt.Color(51, 51, 51))); // NOI18N

        CreatedjLabel.setText("Created");

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(CreatedjLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 459, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addComponent(CreatedjLabel)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 511, Short.MAX_VALUE)
                    .addComponent(IdentificationjLabel, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(workflow_name_JTextfield, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 511, Short.MAX_VALUE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel7, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(IdentificationjLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(workflow_name_JTextfield, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 187, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(39, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Current Workflow", jPanel6);

        jPanel8.setBackground(new java.awt.Color(255, 255, 255));
        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("Developpement options"));

        jCheckBox4.setBackground(new java.awt.Color(255, 255, 255));
        jCheckBox4.setText("Display Running Time (This will display running time on each object)");
        jCheckBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox4ActionPerformed(evt);
            }
        });

        jCheckBox6.setBackground(new java.awt.Color(255, 255, 255));
        jCheckBox6.setText("Enable Developer Mode (Enable object creation and special database functions)");
        jCheckBox6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox6ActionPerformed(evt);
            }
        });

        jCheckBox7.setBackground(new java.awt.Color(255, 255, 255));
        jCheckBox7.setText("Load PhyloWidget (Not loading reduce memory load and speedup)");
        jCheckBox7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox7ActionPerformed(evt);
            }
        });

        jCheckBox8.setBackground(new java.awt.Color(255, 255, 255));
        jCheckBox8.setText("Enable logging of database events (Warning, cause big Armadillo log)");
        jCheckBox8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox8ActionPerformed(evt);
            }
        });

        jPanel9.setBackground(new java.awt.Color(255, 255, 255));
        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("Workflow Display"));

        Separator_jComboBox2.setEditable(true);
        Separator_jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "default", "800", "1200", "3000", "4000" }));
        Separator_jComboBox2.setToolTipText("Note: you can edit this field.");
        Separator_jComboBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Separator_jComboBox2ActionPerformed(evt);
            }
        });

        jLabel5.setText("Width");

        Separator_jComboBox3.setEditable(true);
        Separator_jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "default", "500", "750", "1000", "1250", "1500", "2000", " " }));
        Separator_jComboBox3.setToolTipText("Note: you can edit this field.");
        Separator_jComboBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Separator_jComboBox3ActionPerformed(evt);
            }
        });

        jLabel8.setText("Height");

        SimpleGraphjCheckBox.setBackground(new java.awt.Color(255, 255, 255));
        SimpleGraphjCheckBox.setText("Execution flow graph (advanced)");
        SimpleGraphjCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SimpleGraphjCheckBoxActionPerformed(evt);
            }
        });

        ShowGridjCheckBox.setBackground(new java.awt.Color(255, 255, 255));
        ShowGridjCheckBox.setText("Display Grid");
        ShowGridjCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ShowGridjCheckBoxActionPerformed(evt);
            }
        });

        jLabel9.setText("Note: changes will take effect when Armadillo is restarted.");

        LowResolutionCheckBox.setBackground(new java.awt.Color(255, 255, 255));
        LowResolutionCheckBox.setText("Low resolution graphics (Faster armadillo GUI)");
        LowResolutionCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                LowResolutionCheckBoxActionPerformed(evt);
            }
        });

        fontsize_jComboBox4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "default", "smallest", "-4", "-3", "smaller", "-1", "+1", "bigger", "+3", "+4", "biggest" }));
        fontsize_jComboBox4.setToolTipText("Note: you can edit this field.");
        fontsize_jComboBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fontsize_jComboBox4ActionPerformed(evt);
            }
        });

        jLabel13.setText("Font size");

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel8)
                    .addComponent(jLabel5)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel9)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(fontsize_jComboBox4, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(Separator_jComboBox3, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                            .addComponent(Separator_jComboBox2, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(SimpleGraphjCheckBox)
                            .addComponent(ShowGridjCheckBox)
                            .addComponent(LowResolutionCheckBox))))
                .addContainerGap(30, Short.MAX_VALUE))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(LowResolutionCheckBox)
                    .addComponent(fontsize_jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 10, Short.MAX_VALUE)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Separator_jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(ShowGridjCheckBox)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Separator_jComboBox3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(SimpleGraphjCheckBox)
                    .addComponent(jLabel8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel9))
        );

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Memory (allocated fotr Armadillo)"));

        Memory_jComboBox4.setEditable(true);
        Memory_jComboBox4.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "128m", "256m", "512m", "1024m", "2048m" }));
        Memory_jComboBox4.setSelectedIndex(2);
        Memory_jComboBox4.setToolTipText("Note: you can edit this field.");
        Memory_jComboBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Memory_jComboBox4ActionPerformed(evt);
            }
        });

        jLabel10.setText("Starting memory");

        jLabel11.setFont(new java.awt.Font("Lucida Grande", 0, 12));
        jLabel11.setForeground(new java.awt.Color(255, 0, 0));
        jLabel11.setText("This will take effect the next time you start Armadillo.");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Memory_jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, 343, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Memory_jComboBox4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel10)
                    .addComponent(jLabel11))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel12.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel12.setText("This is some preferences both for the current Workflow and the Armadillo Workflow Platform.");

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel12)
                    .addComponent(jCheckBox4))
                .addContainerGap())
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBox6)
                .addContainerGap(26, Short.MAX_VALUE))
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addComponent(jCheckBox8)
                .addContainerGap())
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addComponent(jCheckBox7)
                .addContainerGap())
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addComponent(jLabel12)
                .addGap(12, 12, 12)
                .addComponent(jCheckBox4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBox8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCheckBox7)
                .addGap(34, 34, 34)
                .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jCheckBox6))
        );

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        jTabbedPane1.addTab("Advanced", jPanel3);

        ClosejButton.setText("Update");
        ClosejButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ClosejButtonActionPerformed(evt);
            }
        });

        CanceljButton.setText("Cancel");
        CanceljButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CanceljButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 624, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ClosejButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(CanceljButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 466, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(CanceljButton)
                    .addComponent(ClosejButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ClosejButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ClosejButtonActionPerformed
       
        this.updateInformations();
        this.setVisible(false);
    }//GEN-LAST:event_ClosejButtonActionPerformed

    private void ShowGridjCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ShowGridjCheckBoxActionPerformed
        workbox.getCurrentArmadilloWorkflow().draw_grid=this.ShowGridjCheckBox.isSelected();
        work.setDisplayLINE(this.ShowGridjCheckBox.isSelected());
        workbox.getCurrentArmadilloWorkflow().force_redraw=true;
        workbox.getCurrentArmadilloWorkflow().redraw();
        modified=true;
    }//GEN-LAST:event_ShowGridjCheckBoxActionPerformed

    private void SimpleGraphjCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SimpleGraphjCheckBoxActionPerformed
      workbox.getCurrentArmadilloWorkflow().simplegraph=this.SimpleGraphjCheckBox.isSelected();
      workbox.getCurrentArmadilloWorkflow().workflow.outputExecution();
      work.setSimpleGraph(this.SimpleGraphjCheckBox.isSelected());
      //-- Update the Execution path
      workbox.outputExecution();
      
      //program.TriTopo(workbox.getCurrentArmadilloWorkflow().workflow, workbox.getCurrentArmadilloWorkflow().workflow.findBegin(), new Vector<workflow_object>());
      workbox.getCurrentArmadilloWorkflow().force_redraw=true;
      workbox.getCurrentArmadilloWorkflow().redraw();
      modified=true;
    }//GEN-LAST:event_SimpleGraphjCheckBoxActionPerformed

    private void workflow_name_JTextfieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_workflow_name_JTextfieldFocusLost
        work.setName(this.workflow_name_JTextfield.getText());
        modified=true;
    }//GEN-LAST:event_workflow_name_JTextfieldFocusLost

    private void CanceljButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CanceljButtonActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_CanceljButtonActionPerformed

    private void Note_jTextAreaFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_Note_jTextAreaFocusLost
        work.setNote(this.Note_jTextArea.getText());
        modified=true;
    }//GEN-LAST:event_Note_jTextAreaFocusLost

    private void ProjectNamejTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProjectNamejTextFieldFocusLost
       workbox.getProject().setName(this.ProjectNamejTextField.getText());
       modified=true;
    }//GEN-LAST:event_ProjectNamejTextFieldFocusLost

    private void ProjectAuthorjTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProjectAuthorjTextFieldFocusLost
       workbox.getProject().setAuthor(this.ProjectAuthorjTextField.getText());
       modified=true;
    }//GEN-LAST:event_ProjectAuthorjTextFieldFocusLost

    private void ProjectEmailjTextFieldFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProjectEmailjTextFieldFocusGained
      
    }//GEN-LAST:event_ProjectEmailjTextFieldFocusGained

    private void ProjectInstitutionjTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProjectInstitutionjTextFieldFocusLost
        workbox.getProject().setInstitution(this.ProjectInstitutionjTextField.getText());
        modified=true;
    }//GEN-LAST:event_ProjectInstitutionjTextFieldFocusLost

    private void ProjectNotejTextAreaFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProjectNotejTextAreaFocusLost
       workbox.getProject().setNote(this.ProjectNotejTextArea.getText());
       modified=true;
    }//GEN-LAST:event_ProjectNotejTextAreaFocusLost

    private void ProjectEmailjTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_ProjectEmailjTextFieldFocusLost
       workbox.getProject().setEmail(this.ProjectEmailjTextField.getText());
       Config config=new Config();
       config.set("email",this.ProjectEmailjTextField.getText());
       config.Save();
    }//GEN-LAST:event_ProjectEmailjTextFieldFocusLost

    private void jCheckBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox4ActionPerformed

        Config config=new Config();
        config.set("Display_elapsed_time",this.jCheckBox4.isSelected());
        config.Save();
       
    }//GEN-LAST:event_jCheckBox4ActionPerformed

    private void jCheckBox6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox6ActionPerformed
        Config config=new Config();
        config.set("DeveloperMode", this.jCheckBox6.isSelected());
        
        Message("Change will take place when you restard Armadilo.","");
        config.Save();
    }//GEN-LAST:event_jCheckBox6ActionPerformed

    private void jCheckBox7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox7ActionPerformed
        Config config=new Config();
        config.set("LoadPhyloWidget",this.jCheckBox7.isSelected());
        config.Save();
    }//GEN-LAST:event_jCheckBox7ActionPerformed

    private void jCheckBox8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox8ActionPerformed
       Config config=new Config();
        config.set("LogDatabaseEvents",this.jCheckBox8.isSelected());
        config.Save();
    }//GEN-LAST:event_jCheckBox8ActionPerformed

    private void Separator_jComboBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Separator_jComboBox2ActionPerformed
        String item=(String)this.Separator_jComboBox2.getSelectedItem();
        Config config=new Config();
        if (item.equals("default")) {
            config.remove("workflow_w");
        } else config.set("workflow_w",item);
       config.Save();

}//GEN-LAST:event_Separator_jComboBox2ActionPerformed

    private void Separator_jComboBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Separator_jComboBox3ActionPerformed
        String item=(String)this.Separator_jComboBox3.getSelectedItem();
        Config config=new Config();
        if (item.equals("default")) {
            config.remove("workflow_h");
        } else config.set("workflow_h",item);
       config.Save();
    }//GEN-LAST:event_Separator_jComboBox3ActionPerformed

    private void Memory_jComboBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Memory_jComboBox4ActionPerformed
        //== Get Information from run.bat
        //== java -Xms128m -Xmx512m -jar Armadillo.jar
        Util u= new Util(Config.currentPath+File.separator+"run.bat");
        Util u2= new Util(Config.currentPath+File.separator+"run.sh");
        String memory=(String)this.Memory_jComboBox4.getSelectedItem();
        u.println("java -Xms128m -Xmx"+memory+" -jar Armadillo.jar");
        //--Note: Added October 2011 - Etienne
        u2.println("#!/bin/sh");
        u2.println("java -Xms128m -Xmx"+memory+" -jar Armadillo.jar");
        u.close();
        u2.close();
    }//GEN-LAST:event_Memory_jComboBox4ActionPerformed

    private void LowResolutionCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_LowResolutionCheckBoxActionPerformed
        Config config=new Config();
        config.set("LowResolution", this.LowResolutionCheckBox.isSelected());
        Message("Change will take place when you restard Armadilo.","");
        config.Save();
    }//GEN-LAST:event_LowResolutionCheckBoxActionPerformed

    private void fontsize_jComboBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fontsize_jComboBox4ActionPerformed
        String item=(String)this.fontsize_jComboBox4.getSelectedItem();
        Config config=new Config(); 
        if (item.equals("default")) {
            config.remove("font_size_adjuster");
        } else {
            //smallest
            //smaller
            //bigger
            //biggest
            if (item.equals("smallest")) config.set("font_size_adjuster", -5);
            if (item.equals("-4")) config.set("font_size_adjuster", -4);
            if (item.equals("-3")) config.set("font_size_adjuster", -3);
            if (item.equals("smaller")) config.set("font_size_adjuster", -2);
            if (item.equals("-1")) config.set("font_size_adjuster", -1);
            if (item.equals("+1")) config.set("font_size_adjuster", 1);
            if (item.equals("bigger")) config.set("font_size_adjuster", +2);
            if (item.equals("+3")) config.set("font_size_adjuster", +3);
            if (item.equals("+4")) config.set("font_size_adjuster", +4);
            if (item.equals("biggest")) config.set("font_size_adjuster", +5);          
        }
        config.Save();
        this.work.workflow.recreateFont();
    }//GEN-LAST:event_fontsize_jComboBox4ActionPerformed

    public void updateUI() {
        String w=String.valueOf(workbox.getCurrentArmadilloWorkflow().width);
        String h=String.valueOf(workbox.getCurrentArmadilloWorkflow().height);                
        //--Project       
        this.ProjectNamejTextField.setText(workbox.getProject().getName());
        this.ProjectInstitutionjTextField.setText(workbox.getProject().getInstitution());
        this.ProjectEmailjTextField.setText(workbox.getProject().getEmail());
        this.ProjectAuthorjTextField.setText(workbox.getProject().getAuthor());
        this.ProjectNotejTextArea.setText(workbox.getProject().getNote());
        if (workbox.getProject().getAuthor().isEmpty()&&config.isSet("author")) {
            this.ProjectAuthorjTextField.setText(config.get("author"));
            workbox.getProject().setAuthor(config.get("author"));
        }
        if (workbox.getProject().getInstitution().isEmpty()&&config.isSet("institution")) {
            this.ProjectInstitutionjTextField.setText(config.get("institution"));
            workbox.getProject().setInstitution(config.get("institution"));
        }
        if (workbox.getProject().getEmail().isEmpty()&&config.isSet("email")) {
            this.ProjectEmailjTextField.setText(config.get("email"));
            workbox.getProject().setEmail(config.get("email"));
        }
        //this.ProjectCreatejLabel.setText("Created on :"+workbox.getProject().getDateCreated());
        //--Workflow
        work=this.workbox.getCurrentWorkflows();
        this.ShowGridjCheckBox.setSelected(work.isDisplayLINE());
        this.SimpleGraphjCheckBox.setSelected(work.isSimpleGraph());
        this.workflow_name_JTextfield.setText(work.getName());
        this.Note_jTextArea.setText(work.getNote());
        this.CreatedjLabel.setText("Created on :"+work.getDate_created());
        Config config=new Config();
        this.jCheckBox6.setSelected(config.isDevelopperMode());        
        this.jCheckBox4.setSelected(config.getBoolean("Display_elapsed_time"));
        this.jCheckBox7.setSelected(config.getBoolean("LoadPhyloWidget"));
        this.jCheckBox8.setSelected(config.getBoolean("LogDatabaseEvents"));
        this.LowResolutionCheckBox.setSelected(config.getBoolean("LowResolution"));
        //this.ModifiedjLabel.setText("Modified on :"+ work.getDate_modified());
        if (config.isSet("workflow_w"))this.Separator_jComboBox2.setSelectedItem(config.get("workflow_w"));
        if (config.isSet("workflow_h"))this.Separator_jComboBox3.setSelectedItem(config.get("workflow_h"));
        //-- Read Memory
        Pattern extract_memory=Pattern.compile("java -Xms(.*)m -Xmx(.*)m -jar Armadillo.jar", Pattern.CASE_INSENSITIVE);
        try {
        String[] s=Util.InputFile(Config.currentPath+"\\run.bat");
        if (s.length>0) {
            for (String s2:s) {
                Matcher m=extract_memory.matcher(s2);
                if (m.find()) {
                    String memory=m.group(2);
                    this.Memory_jComboBox4.setSelectedItem(memory+"m");
                }
            }
         }
        //--Font size
        if (config.isSet("font_size_adjuster")) {
             this.fontsize_jComboBox4.setSelectedItem(config.get("font_size_adjuster"));
        }
        
        } catch (Exception e) {
            //--Probably MAC
            //Do nothing...
        }
        
    }

    public void display() {
        updateUI();
        this.setVisible(true);
    }

    /**
     * Simple thread to load file into the project
     */
    public void updateInformations() {

        SwingWorker<Integer, Object> loadSwingWorker2=new SwingWorker<Integer, Object>() {

            @Override
            protected Integer doInBackground() throws Exception {
            if (modified) {
                workbox.getProject().updateDatabase();
                setProgress(50);
                work.updateDatabase();
            }
                setProgress(100);
                return 0;
            }

            @Override
            public void process(List<Object> chunk) {
                for (Object o:chunk) {
                    if (o instanceof String)  {
                        String s=(String)o;
                        if (s.startsWith("Unable")||s.startsWith("Error")) {
                            loading.MessageErreur(s, "");
                        } else {
                            loading.Message(s,"");
                        } //--End Unable
                     } //--End instance of String
                } //--End list of Object
            } //End process

            @Override
            public void done() {
                 toolbox.reloadDatabaseTree();
                loading.setVisible(false);

            }

        }; //End SwingWorker definition

        loadSwingWorker2.addPropertyChangeListener(
                 new PropertyChangeListener() {
                    public  void propertyChange(PropertyChangeEvent evt) {
                        if ("progress".equals(evt.getPropertyName())) {
                            SwingWorker o = (SwingWorker)evt.getSource();
                            if (!o.isDone()) {
                                int progress=(Integer)evt.getNewValue();
                                loading.setProgress(progress);
                            }
                            else if (o.isDone()&&!o.isCancelled()) {
                               //Handled in done() fucntion in SwingWorker
                            }
                        }//End progress update
                 } //End populateNetworkPropertyChange
                 });
        //Finally. Show a load dialog :: Warning Work-In-Progress
        loading=new InformationJDialog(frame, false, loadSwingWorker2,"");
        loading.setProgress(0); //Put 0% as the start progress
        loading.Message("Updating informations... ","");
        loadSwingWorker2.execute();
    }

      void Message(String text, String tooltip) {
        this.jStatusMessage.setEnabled(true);
        this.jStatusMessage.setForeground(new java.awt.Color(0, 51, 153));
        this.jStatusMessage.setBackground(Color.WHITE);
        this.jStatusMessage.setToolTipText(tooltip);
        this.jStatusMessage.setText(text);
    }


    void MessageError(String text, String tooltip) {
        this.jStatusMessage.setEnabled(true);
        this.jStatusMessage.setForeground(Color.RED);
        this.jStatusMessage.setBackground(Color.WHITE);
        this.jStatusMessage.setToolTipText(tooltip);
        this.jStatusMessage.setText(text);
    }
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton CanceljButton;
    private javax.swing.JButton ClosejButton;
    private javax.swing.JLabel CreatedjLabel;
    private javax.swing.JLabel IdentificationjLabel;
    private javax.swing.JCheckBox LowResolutionCheckBox;
    private javax.swing.JComboBox Memory_jComboBox4;
    private javax.swing.JTextArea Note_jTextArea;
    private javax.swing.JTextField ProjectAuthorjTextField;
    private javax.swing.JTextField ProjectEmailjTextField;
    private javax.swing.JTextField ProjectInstitutionjTextField;
    private javax.swing.JTextField ProjectNamejTextField;
    private javax.swing.JTextArea ProjectNotejTextArea;
    private javax.swing.JComboBox Separator_jComboBox2;
    private javax.swing.JComboBox Separator_jComboBox3;
    private javax.swing.JCheckBox ShowGridjCheckBox;
    private javax.swing.JCheckBox SimpleGraphjCheckBox;
    private javax.swing.JComboBox fontsize_jComboBox4;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JCheckBox jCheckBox8;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextField jStatusMessage;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField workflow_name_JTextfield;
    // End of variables declaration//GEN-END:variables

}
